"use strict";

var focus = angular.module("focus", []);
focus.factory("$focus", function ($timeout, $window) {
  return function (id) {
    $timeout(function () {
      var element = $window.document.getElementById(id);
      if (element) element.focus();
    });
  };
});
var componentMod = angular.module("component", ["focus"]);
componentMod.component("warnTool", {
  template: "<div class='ui-tooltips ui-tooltips-warn i_tooltips' ng-show='$ctrl.show' ng-click='$ctrl.openWirelessSetting()'><div class='ui-tooltips-cnt ui-border-b'><i></i>{{$ctrl.warnMsg}}<a class='ui-icon-close' ng-click='$ctrl.close($event)'></a></div></div>",
  bindings: {
    show: "=",
    warnMsg: "<"
  },
  controller: function controller($scope) {
    this.close = function (e) {
      e.stopPropagation();
      this.show = false;
    };

    this.openWirelessSetting = function () {
      android.openWirelessSetting();
    };
  }
});
componentMod.component("myHeader", {
  template: "<header class='ui-header ui-header-positive'><div ng-click='$ctrl.back()'><i class='ui-icon-return'></i><div class='reback'>{{$ctrl.backtext}}</div></div><h1>{{$ctrl.title}}</h1></header>",
  bindings: {
    back: "&",
    title: "<",
    backtext: "<"
  }
});
componentMod.component("multiselectBox", {
  template: "<div class='mask {{$ctrl.show?'show_mask':''}}' ng-show='$ctrl.show' ng-click='$ctrl.close()'><div class='select_items_container'><ul class='ui-list ui-list-text ui-border-tb query_ui_list'><li class='ui-border-t' ng-repeat='item in $ctrl.arr track by $index' ng-click='$ctrl.stopPropagation($event)'><label class='flex flex1'><span class='ui-list-info flex1'>{{item.name}}</span><div ng-if='!$ctrl.disable' class='ui-radio'><input type='radio' name='one' ng-value='item.value' ng-checked='item.value == $ctrl.currval' ng-model='$ctrl.currval' ng-click='$ctrl.select()'></div></label></li></ul></div></div>",
  bindings: {
    arr: "=",
    //值列表
    show: "=",
    //是否显示该组件
    currval: "=", //当前选择的值
    disable: "="
  },
  controller: function controller($scope) {
    this.close = function () {
      this.show = false;
    };

    this.stopPropagation = function ($event) {
      $event.stopPropagation();
    };

    this.select = function () {
      this.show = false;
    };
  }
});
componentMod.component("preview", {
  template: '<div class="preview_box {{$ctrl.show?\'preview_show\':\'\'}}" ng-show="$ctrl.show" ng-click="$ctrl.hide()"><image src="{{$ctrl.imglist[$ctrl.curr]}}" alt="" class="preview_image"></image><div class="panel" ng-if="$ctrl.imglist.length>1"><div class="banner text_align_center">{{$ctrl.curr + 1}} / {{$ctrl.length}}</div><div id="prevBtn" class="button align_item_center tap_active" ng-click="$ctrl.prev($event)"><div class="arrow i_icon i_icon_arrow_left"></div></div><div id="nextBtn" class="button align_item_center tap_active" ng-click="$ctrl.next($event)"><div class="arrow i_icon i_icon_arrow_right"></div></div></div></div>',
  bindings: {
    show: "=",
    imglist: "<",
    curr: "<"
  },
  controller: function controller($scope) {
    var _this = this;

    this.hide = function () {
      this.show = false;
    };

    this.prev = function (e) {
      e.stopPropagation();
      this.curr = (this.curr + this.prevOffset) % this.length;
    };

    this.next = function (e) {
      e.stopPropagation();
      this.curr = (this.curr + 1) % this.length;
    };

    $scope.$watch("$ctrl.imglist.length", function () {
      _this.length = _this.imglist.length;
      _this.prevOffset = _this.length - 1;
    });
  }
});
componentMod.component("searchbar", {
  template: '<div class="ui-searchbar-wrap {{$ctrl.searchbar.focus?\'focus\':\'\'}}"><div class="ui-searchbar ui-border-radius" ng-click="$ctrl.focus()"><i class="ui-icon-search"></i><div class="ui-searchbar-text">{{$ctrl.searchbar.placeholder}}</div><div class="ui-searchbar-input"><input value="" type="text" placeholder="{{$ctrl.searchbar.placeholder}}"autocapitalize="off" ng-model="$ctrl.searchbar.searchText" id="searchInput"></div><i class="ui-icon-close" ng-click="$ctrl.clear()"></i></div><button class="ui-searchbar-cancel" ng-click="$ctrl.cancel()">{{$ctrl.searchbar.button}}</button><i class="icon iconfont icon-saomiao icon-scan-s" ng-click="$ctrl.preScan($ctrl.searchbar.characteristic)"></i></div>',
  bindings: {
    searchbar: "=",
    scan: "&",
    characteristic: "="
  },
  controller: function controller($scope, $focus) {
    var _this = this;
    this.focus = function () {
      this.searchbar.focus = true;
      $focus("searchInput");
    };

    this.clear = function () {
      this.searchbar.searchText = "";
      $focus("searchInput");
    };

    this.cancel = function () {
      this.searchbar.searchText = "";
      this.searchbar.focus = false;
    };

    this.preScan = function (characteristic) {
      if (characteristic != undefined) {
        this.characteristic = characteristic;
        this.scan({
          characteristic: characteristic
        });
      } else {
        this.scan();
      }
    };

    $scope.$watch("$ctrl.searchbar.searchText", function (newVal) {
      if (newVal) {
        _this.searchbar.focus = true;
      }
    });
  }
});