var app = angular.module("myApp", ["component", "loadMore"]);
app.controller("myCtrl", function ($scope, $http) {

    $scope.data = {
        "pageText": null,
        "header": {
            "title": android.getString("title_accountlist"),
            "backtext": android.getString("back")
        },
        "searchbar": {
            "focus": false,
            "searchText": "",
            "placeholder": "",
            "button": ""
        },
        "reqUrl": android.getReqUrl("accountlist"),
        "accountlist": [],
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "warnning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "accountlist_error": android.getString("accountlist_error")
        },
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "myListConfig": {
            "page": 1,
            "pagesize": 20
        },
        "pullToLoadMore": {
            "show": false,
            "loading": false,
            "text": android.getString("loading")
        },
        "more": true
    }, "searchbar", {
        "focus": false,
        "searchText": "",
        "placeholder": "",
        "button": ""
    };
    $scope.scan = function () {
        accountApi.scan();
    };
    $scope.init = function () {
        this.refresh();
        this.data.pageText = JSON.parse(android.getJsonFromFile("accountList_pageText"));
        this.data.searchbar.placeholder = this.data.pageText.search_placeholder;
        this.data.searchbar.button = this.data.pageText.search_button;
    };
    $scope.loadMore = function () {
        $scope.data.pullToLoadMore = {
            "show": true,
            "loading": true,
            "text": android.getString("loading")
        };
        this.getMyList();
    };
    $scope.refresh = function () {
        this.data.myListConfig.page = 1;
        this.getMyList(true);
    };
    $scope.getMyList = function (isrefresh) {
        if (!android.isNetworkAvailable()) {
            this.data.warnMsg = this.data.warnning_and_error.network_unavailable;
            this.data.showWarn = true;
        } else {
            $http({
                url: $scope.data.reqUrl,
                data: JSON.stringify({
                    "hrid": $scope.data.accountInfo.hrid,
                    "penum": $scope.data.accountInfo.penum,
                    "page": $scope.data.myListConfig.page,
                    "pagesize": $scope.data.myListConfig.pagesize
                }),
                method: "POST",
                responseType: "json"
            }).success(function (res) {
                if (res.success) {
                    $scope.data.myListConfig.page++;
                    var more = Boolean(res.total == $scope.data.myListConfig.pagesize);
                    if (more) {
                        $scope.data.pullToLoadMore = {
                            "show": false,
                            "loading": false
                        };
                    } else {
                        $scope.data.pullToLoadMore = {
                            "show": true,
                            "loading": false,
                            "text": android.getString("no_more")
                        };
                    }
                    $scope.data.more = more;
                    if (isrefresh) $scope.data.accountlist = res.content;
                    else $scope.data.accountlist = $scope.data.accountlist.concat(res.content);
                } else {
                    android.alert(res.message);
                }
                android.refreshComplete();
            }).error(function () {
                android.alert($scope.data.warnning_and_error.accountlist_error);
                android.refreshComplete();
            });
        }
    };
    $scope.modify = function (pageData) {
        accountApi.modify("account.EditAccount", JSON.stringify(pageData));
    };
    $scope.back = function () {
        accountApi.goback();
    };
});

app.filter("accountFilter", function () {
    return function (accountList, condition) {
        if (condition) {
            return accountList.filter(function (account) {
                return (account.roleaccount.toLocaleLowerCase().indexOf(condition.toLocaleLowerCase()) > -1 || account.displayname.toLocaleLowerCase().indexOf(condition.toLocaleLowerCase()) > -1)
            })
        } else return accountList;
    }
});

function pullToRefresh() {
    var ele = angular.element(document.getElementById("myCtrl"));
    var myCtrlScope = ele.scope();
    myCtrlScope.$apply(function () {
        myCtrlScope.refresh();
    });
}

function getScanResult(result) {
    var ele = angular.element(document.getElementById("myCtrl"));
    var scope = ele.scope();
    scope.$apply(function () {
        scope.data.searchbar.searchText = result;
    });
}