var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("editAccount_pageText")),
        "header": {
            "title": android.getString("title_editaccount"),
            "backtext": android.getString("back")
        },
        "reqUrl": android.getReqUrl("editaccount"),
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "targetAccount": JSON.parse(editAccountApi.getPageData()),
        "pw": {
            "pw1": "",
            "pw2": ""
        },
        "loading": false,
        "warnning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "editaccount_error": android.getString("editaccount_error"),
            "input_roleaccount": android.getString("input_roleaccount"),
            "input_displayname": android.getString("input_displayname"),
            "pw_error": android.getString("pw_error"),
            "pw_len": android.getString("pw_len"),
            "pw_not_equal": android.getString("pw_not_equal"),
            "edit_account_success": android.getString("edit_account_success")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        }
    }
    $scope.init = function () {
    }
    $scope.commit = function () {
        if (!android.isNetworkAvailable()) {
            this.data.warnData.warnMsg = this.data.warnning_and_error.network_unavailable;
            this.data.warnData.showWarn = true;
        } else {
            $scope.data.loading = true;
            var postData = this.checkInfo();
            if (postData) {
                $http({
                    url: $scope.data.reqUrl,
                    data: postData,
                    method: "POST",
                    responseType: "json",
                    timeout: 10000
                }).success(function (res) {
                    if (res.success) {
                        android.showToast($scope.data.warnning_and_error.edit_account_success);
                        editAccountApi.goback(1);
                    } else {
                        $scope.data.loading = false
                        android.alert(res.message);
                    }
                }).error(function () {
                    $scope.data.loading = false
                    android.alert($scope.data.warnning_and_error.editaccount_error);
                })
            } else
                $scope.data.loading = false;
        }
    }
    $scope.checkInfo = function () {
        if ($scope.form.displayname.$error.required) {
            android.alert(this.data.warnning_and_error.input_displayname);
            return false
        }
        if ($scope.form.pw1.$error.pattern) {
            android.alert(this.data.warnning_and_error.pw_error);
            return false
        }
        if (this.data.pw.pw1.length && (this.data.pw.pw1.length < 6 || this.data.pw.pw1.length > 20)) {
            android.alert(this.data.warnning_and_error.pw_len);
            return false
        }
        if (this.data.pw.pw1 != this.data.pw.pw2) {
            android.alert(this.data.warnning_and_error.pw_not_equal);
            return false
        }
        var postData = {
            "hrid": this.data.accountInfo.hrid,
            "penum": this.data.accountInfo.penum,
            "rolehrid": this.data.targetAccount.hrid,
            "roleaccount": this.data.targetAccount.roleaccount,
            "displayname": this.data.targetAccount.displayname,
            "isdataadmin": this.data.targetAccount.isdataadmin,
            "ispemgr": this.data.targetAccount.ispemgr
            // "isgeneraluser": this.data.targetAccount.isgeneraluser
        };
        if(this.data.pw.pw1) {
            postData.password = this.data.pw.pw1;
        }
        return postData;
    }
    $scope.back = function () {
        editAccountApi.goback(0);
    }
})