$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});

var app = angular.module('myApp', ['component']);
app.controller('myCtrl', function ($scope, $http, $focus, $interval) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("bleBind_pageText")),
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "reqUrl": {
            "getLocList": android.getReqUrl("locList"),
            "editloc": android.getReqUrl("editloc")
        },
        "header": {
            "title": android.getString("title_bleBind"),
            "backtext": android.getString("back")
        },
        "warning_and_error": {
            "index_error": android.getString("index_error"),
            "network_unavailable": android.getString("network_unavailable"),
            "match_bluetooth_failed": android.getString("match_bluetooth_failed"),
            "loc_and_bleid": android.getString("loc_and_bleid")
        },
        "prompt": {
            "bound_bleid": android.getString("bound_bleid"),
            "finished_sync_loc": android.getString("finished_sync_loc"),
            "have_no_loc_to_sync": android.getString("have_no_loc_to_sync")
        },
        "currentLocName": "",
        "bleContent": "",
        "searching": false,
        "searchbar": {
            "searchText": "",
            "focus": true,
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "locList": {
            "unfinishedList": [],
            "finishedList": []
        },
        "flag": true,
        "multiSelectBox": {
            "show": false,
            "currVal": "",
            "arr": [],
            "target": null
        },
        "currLoc": {},
        "uploadStatus": {
            "total": 0,
            "success": 0,
            "failed": 0,
            "successList": [],
            "failedList": []
        }
    }
    $scope.init = function () {
        this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        if (bleBindApi.getLocTotal(this.data.accountInfo.penum) == 0) {
            this.refresh();
        } else {
            var locList = JSON.parse(bleBindApi.getLocList(this.data.accountInfo.penum));
            this.data.locList.unfinishedList = locList.unfinishedList;
            this.data.locList.finishedList = locList.finishedList;
        }
    }
    $scope.back = function () {
        bleBindApi.goback();
    }
    $scope.beforeRefresh = function () {
        android.dialog(android.getString("confirm_to_reset_location"), "", "refresh()", "");
    }
    $scope.refresh = function () {
        if (android.isNetworkAvailable()) {
            console.log(android.isRefresing());
            if(android.isRefresing()) return;
            this.updateLocList();
        } else {
            this.data.warnData.showWarn = true;
        }
    }
    $scope.updateLocList = function () {
        android.setRefresh();
        $http({
            url: $scope.data.reqUrl.getLocList,
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "pagesize": 2000,
                "active": "1",
                "labeltype": "bluetooth"
            },
            method: "post",
            responseType: "json",
            timeout: 20000
        }).success(function (res) {
            if (res.success) {
                bleBindApi.updateLocList($scope.data.accountInfo.penum, JSON.stringify(res.content)); // 更新本地巡更点
                $scope.data.locList = JSON.parse(bleBindApi.getLocList($scope.data.accountInfo.penum)); // 从本地数据库中获取巡更点
                android.showToast(android.getString("refreshComplete"));
            } else
                android.alert(res.message);
            android.refreshComplete();
        }).error(function () {
            android.refreshComplete();
            android.alert($scope.data.warning_and_error.index_error);
        })
    }
    $scope.back = function () {
        bleBindApi.goback();
    }
    $scope.clear = function () {
        this.data.currentLocName = "";
        this.data.bleContent = "";
        this.data.searchbar.searchText = "";
        this.data.multiSelectBox.currVal = "";
        this.data.multiSelectBox.arr = [];
    }
    $scope.setSearching = function (isSearching) {
        this.data.searching = isSearching;
        $focus("searchInput");
        bleBindApi.setSearching(isSearching);
        this.data.searching = isSearching;
    }
    $scope.clickLoc = function (loc) {
        this.data.currLoc = loc;
        this.setSearching(false);
        this.data.searchbar.searchText = "";
    }
    $scope.searchBLE = function () {
        bleBindApi.searchBLE();
    }
    $scope.updateLocBleId = function () {
        if (!this.data.multiSelectBox.currVal || !this.data.currLoc.locdesc) {
            android.showToast(this.data.warning_and_error.loc_and_bleid);
            return;
        }
        android.setRefresh();
        bleBindApi.updateLocBleId(this.data.accountInfo.penum, this.data.currLoc.location, this.data.multiSelectBox.currVal);
        this.finishedLoc(this.data.currLoc, this.data.multiSelectBox.currVal);
        android.refreshComplete();
    }
    $scope.finishedLoc = function (loc, newbleid) {
        loc.newbleid = newbleid;
        var temUnfinishedList = this.data.locList.unfinishedList;
        for (var i = 0, len = temUnfinishedList.length; i < len; i++) {
            if (temUnfinishedList[i].location == loc.location) {
                temUnfinishedList.splice(i, 1);
                this.data.locList.finishedList.push(loc);
                break;
            }
        }
        this.data.currLoc = {};
        this.data.multiSelectBox.currVal = "";
        android.showToast(this.data.prompt.bound_bleid);
    }
    $scope.setBLEList = function (BLEList) {
        var BLEArr = JSON.parse(BLEList);
        this.clearBLEList();
        if (BLEArr.length) {
            BLEArr.forEach(function (item) {
                $scope.data.multiSelectBox.arr.push({
                    name: item,
                    value: item
                })
            });
            this.setisshow(true);
        } else {
            android.showToast(this.data.warning_and_error.match_bluetooth_failed);
        }
    }
    $scope.setisshow = function (isshow) {
        this.data.multiSelectBox.show = isshow;
        bleBindApi.setisshow(isshow);
    }
    $scope.syncLocList = function () {
        console.log(android.isRefresing());
        if(android.isRefresing()) return;
        var syncList = this.data.locList.finishedList.filter(function (item) {
            return item.newbleid;
        })
        if (syncList.length) {
            if(android.isNetworkAvailable()) {
                android.setRefresh();
                this.data.uploadStatus.total = syncList.length;
                this.data.uploadStatus.success = 0;
                this.data.uploadStatus.failed = 0;
                this.data.uploadStatus.successList = [];
                this.data.uploadStatus.failedList = [];
                var times = this.data.uploadStatus.total - 1;
                var count = 1;
    
                this.syncLoc(syncList[0], true);
                if (times) { //一个地点以上
                    $interval(function () { //第二个地点始每个地点延时两秒钟上传
                        $scope.syncLoc(syncList[count++], true);
                    }, 2000, times);
                }
            } else {
                this.data.warnData.showWarn = true;
            }
        } else {
            android.showToast(this.data.prompt.have_no_loc_to_sync);
        }
    }
    $scope.syncLoc = function (loc) {
        $http({
            url: $scope.data.reqUrl.editloc,
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "location": loc.location,
                "description": loc.locdesc,
                "bluetoothid": loc.newbleid,
                "isbluetooth": true
            },
            method: "post",
            responseType: "json",
            timeout: 20000
        }).success(function (res) {
            if (res.success) {
                $scope.data.uploadStatus.success++;
                $scope.data.uploadStatus.successList.push(loc.location);
            } else {
                $scope.data.uploadStatus.failed++;
                $scope.data.uploadStatus.failedList.push(loc.locdesc);
            }
            $scope.checkUploadStatus();
        }).error(function () {
            $scope.data.uploadStatus.failed++;
            $scope.data.uploadStatus.failedList.push(loc.locdesc);
            $scope.checkUploadStatus();
            // android.refreshComplete();
            // android.alert($scope.data.warning_and_error.index_error);
        })
    }
    $scope.checkUploadStatus = function () {
        if (this.data.uploadStatus.success + this.data.uploadStatus.failed == this.data.uploadStatus.total) {
            if(this.data.uploadStatus.failed) {
                android.alert(android.getCustomString("sync_failed_loc_list", this.data.uploadStatus.failedList.join(", ")));
            }
            if(this.data.uploadStatus.success) {
                bleBindApi.clearSyncLoc(this.data.accountInfo.penum, JSON.stringify(this.data.uploadStatus.successList));
            }
            android.showToast(this.data.prompt.finished_sync_loc);
            android.refreshComplete();
            this.refresh();
        }
    }
    $scope.clearBLEList = function () {
        this.data.multiSelectBox.arr = [];
    }
    $scope.$watch("data.multiSelectBox.show", function (newVal) {
        bleBindApi.setisshow(newVal);
    });
});
app.filter("locFilter", function () {
    return function (locList, condition) {
        if (condition) {
            return locList.filter(function (loc) {
                return loc.locdesc.toLocaleLowerCase().indexOf(condition.toLocaleLowerCase()) > -1
            })
        } else return locList;
    }
});
app.factory("$focus", function ($timeout, $window) {
    return function (id) {
        $timeout(function () {
            var element = $window.document.getElementById(id);
            if (element) element.focus();
        });
    };
});
app.component("searchtool", {
    template: '<div class="ui-searchbar-wrap {{$ctrl.searchbar.focus?\'focus\':\'\'}}"><div class="ui-searchbar ui-border-radius" ng-click="$ctrl.focus()"><i class="ui-icon-search"></i><div class="ui-searchbar-text">{{$ctrl.searchbar.placeholder}}</div><div class="ui-searchbar-input"><input value="" type="text" placeholder="{{$ctrl.searchbar.placeholder}}"autocapitalize="off" ng-model="$ctrl.searchbar.searchText" id="searchInput"></div><i class="ui-icon-close" ng-click="$ctrl.clear()"></i></div></div>',
    bindings: {
        searchbar: "=",
        scan: "&",
        characteristic: "="
    },
    controller: function controller($scope, $focus) {
        var _this = this;
        this.focus = function () {
            this.searchbar.focus = true;
            $focus("searchInput");
        };

        this.clear = function () {
            this.searchbar.searchText = "";
            $focus("searchInput");
        };

        this.cancel = function () {
            this.searchbar.searchText = "";
            this.searchbar.focus = false;
        };

        this.preScan = function (characteristic) {
            if (characteristic != undefined) {
                this.characteristic = characteristic;
                this.scan({
                    characteristic: characteristic
                });
            } else {
                this.scan();
            }
        };

        $scope.$watch("$ctrl.searchbar.searchText", function (newVal) {
            if (newVal) {
                _this.searchbar.focus = true;
            }
        });
    }
})
app.component("myHeaderP", {
    template: "<header class='ui-header ui-header-positive'><div ng-click='$ctrl.back()'><i class='ui-icon-return'></i><div class='reback'>{{$ctrl.backtext}}</div></div><h1>{{$ctrl.title}}</h1><div class='right-item' ng-click='$ctrl.refresh()'><div></div><i class='ui-icon-refresh'></i></div></header>",
    bindings: {
        back: "&",
        title: "<",
        backtext: "<",
        refresh: "&"
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function setSearching() {
    angularApply(function () {
        scope.setSearching(false);
    })
}

// function finishedLoc(loc) {
//     angularApply(function () {
//         scope.data.currentLocName = "";
//         scope.finishedLoc(loc);
//     })
// }

function refresh() {
    angularApply(function () {
        scope.refresh();
    })
}

function setBLEList(BLEList) {
    angularApply(function () {
        scope.setBLEList(BLEList);
    })
}

function setisshow() {
    angularApply(function () {
        scope.setisshow(false);
    })
}