var app = angular.module('myApp', ["component"]);
app.controller('myCtrl', function ($scope, $http, $sce) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("eventReport_pageText")),
        "header": {
            "title": null,
            "backText": android.getString("back")
        },
        "reqUrl": android.getReqUrl("eventdetail"),
        "pageData": null,
        "warnData": {
            "showWarn": false,
            "warnMsg": null
        },
        "warning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "eventdetail_error": android.getString("eventdetail_error"),
            "input_description": android.getString("event_input_description"),
            "input_locdesc": android.getString("event_input_locdesc")
        },
        "wonum": null,
        "eventDetail": {},
        "createEvent": false,
        "imgList": [],
        "audioList": [],
        "preview": {
            "imgList": [],
            "show": false
        },
        "priority": null,
        "multiSelectBox": {
            "show": false,
            "currVal": "",
            "arr": null,
            "target": null
        },
        "imgListChanged": false,
        "videoOriSrc": "",
        "videoSrc": [],
        "deletedVideoList": [],
        "newVideoList": [],
        "audioOriSrc": "",
        "audioSrc": "",
        "playingAudio": false
    };
    $scope.init = function () {
        this.data.pageData = JSON.parse(eventReportApi.getPageData());
        this.data.createEvent = !this.data.pageData.getDetail;
        this.setPriority();
        if (this.data.pageData.getDetail) { //获取事件报告详情
            if (this.data.pageData.update) {
                this.data.header.title = android.getString("title_editEventReport")
            } else {
                this.data.header.title = android.getString("title_eventReportDetail");
            }
            if (this.data.pageData.isHistory)
                this.refresh();
            else {
                android.setRefreshDisable();
                this.data.eventDetail = this.data.pageData;
                var imgList = JSON.parse(eventReportApi.getImg(this.data.pageData.ernum));
                if (imgList.pic1) {
                    this.data.imgList.push(imgList.pic1);
                    if (imgList.pic2) {
                        this.data.imgList.push(imgList.pic2);
                        if (imgList.pic3)
                            this.data.imgList.push(imgList.pic3);
                    }
                }
                this.data.videoSrc = JSON.parse(this.data.eventDetail.video);
                this.data.videoOriSrc = this.data.videoSrc.slice(0);
                // this.data.videoSrc = this.data.videoOriSrc = this.data.eventDetail.video;
                this.data.audioSrc = this.data.audioOriSrc = this.data.eventDetail.audio;
            }
        } else {
            android.setRefreshDisable();
            this.data.eventDetail.description = this.data.pageData.description;
            this.data.eventDetail.locdesc = this.data.pageData.locdesc;
            this.data.header.title = android.getString("title_createEvent");
            var nowDate = new Date();
            this.data.eventDetail.createbyname = eventReportApi.getDisplayName();
            this.data.eventDetail.createdate = nowDate.toLocaleString("zh-CN", {
                hour12: false
            }).replace(/\//g, "-").replace(/-(?!\d\d)/g, "-0");
            this.data.eventDetail.priority = "";
        }
    }

    $scope.setPriority = function () {
        var lang = android.getsyslang();
        switch (lang) {
            case "ZH":
                this.data.priority = [{
                    "name": "高",
                    "value": "高"
                }, {
                    "name": "中",
                    "value": "中"
                }, {
                    "name": "低",
                    "value": "低"
                }];
                break;
            case "ZHT":
                this.data.priority = [{
                    "name": "高",
                    "value": "高"
                }, {
                    "name": "中",
                    "value": "中"
                }, {
                    "name": "低",
                    "value": "低"
                }];
                break;
            case "EN":
                this.data.priority = [{
                    "name": "High",
                    "value": "High"
                }, {
                    "name": "Medium",
                    "value": "Medium"
                }, {
                    "name": "Low",
                    "value": "Low"
                }];
                break;
        }
    }

    $scope.refresh = function () {
        if (!this.data.pageData.isHistory) {
            return;
        }
        if (!android.isNetworkAvailable()) {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.eventdetail_error;
        } else {
            $http({
                url: $scope.data.reqUrl,
                data: JSON.stringify({
                    "hrid": $scope.data.pageData.hrid,
                    "penum": $scope.data.pageData.penum,
                    "ernum": $scope.data.pageData.ernum
                }),
                method: "POST",
                responseType: "json"
            }).success(function (res) {
                if (res.success) {
                    $scope.data.eventDetail = res.content;
                    var temImgList = [];
                    if (res.content.picurl1) {
                        temImgList.push(res.content.picurl1);
                        if (res.content.picurl2) {
                            temImgList.push(res.content.picurl2)
                            if (res.content.picurl3) {
                                temImgList.push(res.content.picurl3);
                            }
                        }
                    }
                    $scope.data.imgList = temImgList;
                    $scope.data.videoSrc = res.content.vedios;
                    $scope.data.audioSrc = res.content.studios[0];
                } else
                    android.alert(res.message);
                android.refreshComplete()
            }).error(function () {
                android.refreshComplete();
                android.alert($scope.data.warning_and_error.eventdetail_error);
            })
        }
    }

    $scope.checkInfo = function () {
        if (this.form.description.$error.required) {
            android.alert(this.data.warning_and_error.input_description);
            return false;
        }
        if (this.data.eventDetail.description.length > 100) {
            android.alert(android.getCustomString("event_description_error", this.data.eventDetail.description.length.toString()));
            return false;
        }
        if (this.form.locdesc.$error.required) {
            android.alert(this.data.warning_and_error.input_locdesc);
            return false;
        }
        if (this.data.eventDetail.locdesc.length > 50) {
            android.alert(android.getCustomString("event_locdesc_error", this.data.eventDetail.locdesc.length.toString()));
            return false;
        }
        return true;
    }

    $scope.addPic = function () {
        eventReportApi.addPic();
    }

    $scope.preview = function (curr) {
        // this.data.preview.img = item;
        if (this.data.imgListChanged) {
            this.data.preview.imgList = this.data.imgList.map(function (img) {
                return img;
            });
            this.data.imgListChanged = false;
        }
        this.data.preview.curr = curr;
        this.data.preview.show = true;
        eventReportApi.setishow();
    }

    $scope.deleteImg = function (index) {
        this.data.imgList.splice(index, 1);
    }

    $scope.save = function () {
        if ($scope.checkInfo()) {
            // if (this.data.createEvent || this.data.eventDetail.sync == "UnSync") {
            var accountInfo = JSON.parse(android.getAccountInfo());
            var ernum = this.data.eventDetail.ernum;
            if (!ernum) {
                ernum = eventReportApi.getNewErnum();
            }
            var saveData = {
                "hrid": accountInfo.hrid,
                "penum": accountInfo.penum,
                "ernum": ernum,
                "wonum": this.data.pageData.wonum || "",
                "description": this.data.eventDetail.description,
                "locdesc": this.data.eventDetail.locdesc,
                "createdate": this.data.eventDetail.createdate,
                "createbyname": this.data.eventDetail.createbyname,
                "priority": this.data.eventDetail.priority,
                "pic1": this.data.imgList[0] || "",
                "pic2": this.data.imgList[1] || "",
                "pic3": this.data.imgList[2] || "",
                "video": JSON.stringify(this.data.videoSrc),
                "audio": this.data.audioSrc
            };
            // if (this.data.videoOriSrc && this.data.videoSrc != this.data.videoOriSrc) {
            //     android.deleteFile(this.data.videoOriSrc);
            // }
            if (this.data.deletedVideoList.length) {
                this.data.deletedVideoList.forEach(function (item) {
                    android.deleteFile(item)
                });
            }
            if (this.data.audioOriSrc && this.data.audioSrc != this.data.audioOriSrc) {
                android.deleteFile(this.data.audioSrc);
            }
            if (this.data.createEvent)
                eventReportApi.save(JSON.stringify(saveData));
            else
                eventReportApi.update(JSON.stringify(saveData), this.data.pageData.index);
            // } else {
            //需处理的事件报告，暂时搁置
            // $http({
            //     url: android.getString("rptresultsUrl"),
            //     data: {},
            //     method: "post",
            //     "responseType": "json"
            // }).success(function(res) {
            //     if(res.success) {

            //     }
            // }).error(function () {})
            // }
        }

    }

    $scope.multiSelect = function (arr, currVal, target) {
        if (this.data.pageData.deal || this.data.pageData.isHistory)
            return;
        this.data.multiSelectBox.arr = arr;
        this.data.multiSelectBox.currVal = currVal;
        this.data.multiSelectBox.show = true;
        this.data.multiSelectBox.target = target;
    }

    $scope.audioRecord = function () {
        if (this.getPlayingAudio()) {
            this.stopPlayAudio();
        }
        eventReportApi.audioRecord();
    }

    $scope.videoRecord = function () {
        if (this.data.videoSrc.length == 3) {
            return;
        }
        eventReportApi.videoRecord();
    }

    $scope.$watch("data.multiSelectBox.currVal", function (newVal, oldVal) {
        switch ($scope.data.multiSelectBox.target) {
            case "priority":
                $scope.data.eventDetail.priority = newVal;
                break;
            default:
                break;
        }
    })

    $scope.$watch("data.imgList.length", function () {
        $scope.data.imgListChanged = true;
    })

    $scope.back = function () {
        // if (this.data.videoSrc && this.data.video != this.data.videoOriSrc) {
        //     android.deleteFile(this.data.videoSrc)
        // }
        if (this.data.newVideoList.length) {
            this.data.newVideoList.forEach(function (item) {
                android.deleteFile(item);
            })
        }
        if (this.data.audioSrc && this.data.audio != this.data.audioOriSrc) {
            android.deleteFile(this.data.audioSrc)
        }
        eventReportApi.cancel();
    }

    $scope.playVideo = function (e, index) {
        e.stopPropagation();
        var ernum = "";
        if (this.data.pageData.isHistory) {
            ernum = this.data.pageData.ernum
        }
        eventReportApi.playVideo(this.data.videoSrc[index], ernum, index + 1);
    }
    $scope.audioOperate = function (e) {
        e.stopPropagation();
        if (this.getPlayingAudio()) {
            this.stopPlayAudio();
        } else {
            this.playAudio();
        }
    }
    $scope.playAudio = function () {
        eventReportApi.playAudio(this.data.audioSrc);
    }
    $scope.stopPlayAudio = function () {
        eventReportApi.stopPlayAudio();
    }
    $scope.deleteVideo = function (e, index) {
        e.stopPropagation();
        // if (this.data.videoSrc != this.data.videoOriSrc) {
        //     android.deleteFile(this.data.videoSrc);
        // }
        this.data.deletedVideoList.push(this.data.videoSrc.splice(index, 1));
        // this.data.videoSrc = "";
    }
    $scope.deleteAudio = function (e) {
        e.stopPropagation();
        if (this.data.getPlayingAudio()) {
            this.data.stopPlayAudio();
        }
        if (this.data.audioSrc != this.data.audioOriSrc) {
            android.deleteFile(this.data.audioSrc);
        }
        this.data.audioSrc = "";
    }
    $scope.trustSrc = function (src) {
        return $sce.trustAsResourceUrl(src);
    }
    $scope.setPlayingAudio = function (isPlaying) {
        this.data.playingAudio = isPlaying;
        eventReportApi.setPlayingAudio(isPlaying);
    }
    $scope.getPlayingAudio = function () {
        return this.data.playingAudio;
    }
    $scope.getFileName = function (path) {
        return path.split("/").pop();
    }
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    })
}

function getImg(base64) {
    angularApply(function () {
        scope.data.imgList.push(base64);
    })
}

function closeimage() {
    angularApply(function () {
        scope.data.preview.show = false;
    })
}

function setVideoSrc(src) {
    angularApply(function () {
        // scope.data.videoSrc = src;
        scope.data.videoSrc.push(src);
        scope.data.newVideoList.push(src);
    })
}

function setAudioSrc(src) {
    angularApply(function () {
        scope.data.audioSrc = src;
    })
}

function startPlayAudio() {
    angularApply(function () {
        scope.setPlayingAudio(true)
    })
}

function stopPlayAudio() {
    angularApply(function () {
        scope.setPlayingAudio(false)
    })
}

function completePlayAudio() {
    angularApply(function () {
        scope.setPlayingAudio(false)
    })
}