$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});
var app = angular.module('myApp', ["component", "loadMore", "pr.longpress"]);
app.controller('myCtrl', function ($scope, $http) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("eventlist_pageText")),
        "url": {
            "addEventUrl": android.getReqUrl("addevent"),
            "eventHistory": android.getReqUrl("eventhistory")
        },
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "header": {
            "title": android.getString("title_eventList"),
            "backtext": android.getString("back")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": null
        },
        "warning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "eventList_error": android.getString("eventlist_error"),
            "eventHistory_error": android.getString("eventhistory_error"),
            "syncevent_error": android.getString("syncevent_error"),
            "uploading_eventreport": android.getString("uploading_eventreport"),
            "success_upload_eventreport": android.getString("success_upload_eventreport")
        },
        "eventList": [],
        "total": 0,
        "targetItem": null,
        "showActionSheet": "",
        "delMsg": "",
        "history": {
            "total": "",
            "list": []
        },
        "myListConfig": {
            "history": {
                "page": 1,
                "pagesize": 20
            }
        },
        "pullToLoadMore": {
            "history": {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            }
        },
        "more": {
            "list": true,
            "history": true
        },
        "isme": "0",
        "localEventReportList": [],
        "upload": {
            "total": 0,
            "success": 0,
            "failed": 0
        }
    }

    $scope.init = function () {
        this.getNewEventReport(this.data.accountInfo.hrid, this.data.accountInfo.penum); //获取未同步的事件报告
        this.refresh();
    }

    $scope.back = function () {
        eventListApi.goback();
    }

    $scope.refresh = function () {
        if (android.isNetworkAvailable()) {
            android.setRefresh();
            this.data.myListConfig.history.page = 1;
            this.data.pullToLoadMore.history = {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            };
            this.data.myListConfig = {
                "history": {
                    "page": 1,
                    "pagesize": 20
                }
            };
            this.data.more.history = true;
            this.getHistory(true)
        } else {
            android.refreshComplete();
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }

    $scope.loadMoreHistory = function () {
        if (this.data.more.history) {
            $scope.data.pullToLoadMore.history = {
                "show": true,
                "loading": true,
                "text": android.getString("loading")
            }
            this.getHistory();
        }
    }

    $scope.refreshHistory = function () {
        if (android.isNetworkAvailable()) {
            android.setRefresh();
            this.data.myListConfig.history.page = 1;
            this.data.pullToLoadMore.history = {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            };
            this.data.myListConfig = {
                "history": {
                    "page": 1,
                    "pagesize": 20
                }
            };
            this.data.more.history = true;
            this.getHistory(true)
        } else {
            android.refreshComplete();
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }

    $scope.getHistory = function (refresh) {
        $http({
            url: $scope.data.url.eventHistory,
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "isme": $scope.data.isme,
                "page": $scope.data.myListConfig.history.page,
                "pagesize": $scope.data.myListConfig.history.pagesize
            },
            method: "post",
            responseType: "json"
        }).success(function (res) {
            if (res.success) {
                if (refresh) {
                    $scope.data.history.total = res.total;
                    $scope.data.history.list = res.content;
                } else {
                    $scope.data.history.total += res.total;
                    $scope.data.history.list = $scope.data.history.list.concat(res.content);

                }
                $scope.data.myListConfig.history.page++;
            } else {
                android.alert(res.message);
            }
            var more = $scope.data.myListConfig.history.pagesize == res.total;
            if (more) {
                $scope.data.pullToLoadMore.history = {
                    "show": false,
                    "loading": false
                }
            } else {
                $scope.data.pullToLoadMore.history = {
                    "show": true,
                    "loading": false,
                    "text": android.getString("no_more")
                }
                $scope.data.more.history = false;
            }
            android.refreshComplete();
        }).error(function () {
            android.refreshComplete();
            android.showToast($scope.data.warning_and_error.eventList_error);
        })
    }

    $scope.checkRefreshStatus = function () {
        var pullToLoadMore = this.data.pullToLoadMore;
        if (!pullToLoadMore.history.loading) {
            android.refreshComplete();
        }
    }

    $scope.eventDetail = function (item, deal, isHistory, index) {
        if (item.ernum.indexOf("NEW") > -1) {
            var parama = item;
            parama.getDetail = true;
            parama.isHistory = isHistory;
            parama.index = index;
            parama.update = true;
            eventListApi.updateEventReport(JSON.stringify(parama));
        } else {
            var parama = {
                "hrid": this.data.accountInfo.hrid,
                "penum": this.data.accountInfo.penum,
                "ernum": item.ernum,
                "getDetail": true,
                "deal": deal,
                "isHistory": isHistory
            }
            eventListApi.openActWithData("event.EventReport", JSON.stringify(parama));
        }
    }

    $scope.createEventReport = function () {
        eventListApi.createEventReport(JSON.stringify({
            "hrid": this.data.accountInfo.hrid,
            "penum": this.data.accountInfo.penum
        }))
    }

    $scope.getNewEventReport = function (hrid, penum) {
        this.data.localEventReportList = JSON.parse(eventListApi.getNewEventReport(hrid, penum));
        this.data.total = this.data.localEventReportList.length;
    }

    $scope.confirmSync = function (e, item) { //同步单个事件报告
        e.stopPropagation();
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            this.syncEventReport(item)
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }

    $scope.confirmSyncAll = function () { //同步所有事件报告
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            if (this.data.localEventReportList.length) {
                eventListApi.loadingDialog();
                this.data.upload.total = this.data.localEventReportList.length;
                for (var i = 0; i < $scope.data.upload.total; i++) {
                    $scope.syncEventReport($scope.data.localEventReportList[i], true, i);
                }
            } else {
                android.showToast(android.getString("do_not_need_to_sync_event_report"));
            }
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }

    $scope.syncEventReport = function (item, syncAll, index) { //同步事件报告
        if (!syncAll) {
            eventListApi.loadingDialog();
        }
        var data = {
            "hrid": $scope.data.accountInfo.hrid,
            "penum": $scope.data.accountInfo.penum,
            "wonum": item.wonum,
            "description": item.description,
            "locdesc": item.locdesc,
            "priority": item.priority,
            "vedios": [],
            "studios": []
        };
        var imgList = JSON.parse(eventListApi.getImg(item.ernum));
        if (imgList.pic1) {
            data.pic1 = imgList.pic1;
            if (imgList.pic2) {
                data.pic2 = imgList.pic2;
                if (imgList.pic3)
                    data.pic3 = imgList.pic3;
            }
        }
        var videosList = JSON.parse(item.video);
        // if (item.video) {
        //     data.vedios.push("data:video/mp4;base64," + android.fileToBase64(item.video));
        // }
        if(videosList.length) {
            videosList.forEach(function(video) {
                data.vedios.push("data:video/mp4;base64," + android.fileToBase64(video));
            });
        }
        if (item.audio) {
            data.studios.push("data:audio/mp3;base64," + android.fileToBase64(item.audio));
        }
        $http({
            url: $scope.data.url.addEventUrl,
            data: data,
            method: "POST",
            responseType: "json"
        }).success(function (res) {
            if (res.success) {
                eventListApi.syncEventReport(item.ernum, res.content.ernum);
                if (syncAll) {
                    $scope.data.upload.success++;
                    $scope.completeSyncAll()
                } else {
                    eventListApi.successLoadingDialog();
                }
                if (!syncAll) {
                    $scope.getNewEventReport($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum); //获取未同步的事件报告
                }
                if (data.vedios)
                    android.deleteFile(item.video);
                    android.deleteFile(item.audio);
            } else {
                if (syncAll) {
                    $scope.data.upload.failed++;
                    $scope.completeSyncAll();
                } else
                    android.alert(res.message);
            }
        }).error(function () {
            if (syncAll) {
                $scope.data.upload.failed++;
                $scope.completeSyncAll();
            } else {
                eventListApi.failedLoadingDialog();
            }
            $scope.data.imgList = [];
        })
    }

    $scope.completeSyncAll = function () {
        if (this.data.upload.failed + this.data.upload.success == this.data.upload.total) {
            if (this.data.upload.success)
                eventListApi.successLoadingDialog();
            else
                eventListApi.failedLoadingDialog();
            android.showToast(android.getCustomString("total_of_sync_event_report", $scope.data.upload.success.toString()));
            $scope.getNewEventReport($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum); //在列表前插入未同步的事件报告
            $scope.data.upload = {
                "total": 0,
                "success": 0,
                "failed": 0
            }
        }
    }

    $scope.onLongPress = function (ernum, index) {

        this.data.showActionSheet = "show";
        this.data.targetItem = {
            "ernum": ernum,
            "index": index
        }
    }

    $scope.hide = function () {
        this.data.showActionSheet = "";
    }

    $scope.delete = function (item) {
        if (eventListApi.deleteRow(item.ernum)) {
            this.data.delMsg = android.getCustomString("delete_event_report_success", item.ernum);
            this.data.localEventReportList.splice(item.index, 1);
        } else {
            this.data.delMsg = android.getCustomString("delete_event_report_failed", item.ernum);
        }
        this.data.showActionSheet = "";
        android.showToast(this.data.delMsg);
    }
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.init();
    });
}

function prependEventReport(pageData) { //在事件列表的开始位置插入新的事件报告
    angularApply(function () {
        scope.data.localEventReportList.splice(0, 0, pageData);
    });
}

function updateEventReport(pageData, index) {
    angularApply(function () {
        scope.data.localEventReportList[index] = pageData;
    });
}