"use strict";

var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http, $interval) {
    $scope.data = {
        "pageText": null,
        "header": {
            "title": android.getString("title_forgetpw"),
            "backtext": android.getString("back")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": android.getString("network_unavailable")
        },
        "reqUrl": {
            "checkphone": android.getReqUrl("checkphone"),
            "gencode": android.getReqUrl("gencode"),
            "checkverifycode": android.getReqUrl("checkverifycode"),
            "changepw": android.getReqUrl('changepw'),
            "checkroleaccount": android.getReqUrl("checkroleaccount")
        },
        "langcode": forgetApi.getsyslang(),
        "commiting": false,
        "type": "",
        "flag": null,
        "hrid": "",
        "peab": "",
        "account": "",
        "admin": "",
        "admin1": "",
        "admin2": "",
        "isCountdown": false,
        "countdown": 60
    };

    $scope.init = function () {
        this.data.pageText = JSON.parse(android.getJsonFromFile("forgetPw_pageText"));
        this.data.type = forgetApi.getType();
        if (this.data.type == "account") {
            this.data.flag = 2;
        } else if (this.data.type = "mobile") {
            this.data.flag = 0;
        }
    };
    $scope.commit = function () {
        if (android.isNetworkAvailable()) {
            this.data.commiting = true;
            switch (this.data.flag) {
                case 0:
                    this.checkPhone();
                    break;
                case 1:
                    this.checkPassword();
                    break;
                case 2:
                    this.checkpeab();
                    break;
                case 3:
                    this.checkAdmin();
                    break;
            }
        } else {
            this.data.warnData.showWarn = true;
        }
    };

    $scope.getCode = function () {
        if (!this.data.isCountdown) {
            $http({
                url: $scope.data.reqUrl.checkphone,
                method: "POST",
                data: {
                    "phone": $scope.data.phone,
                    "type": "2",
                    "langcode": $scope.data.langcode
                },
                responseType: "json",
                timeout: 10000
            }).success(function (res) {
                if (res.success) {
                    android.showToast("正在发送验证码，请稍候");
                    $scope.countdown();
                    $scope.gencode();
                } else {
                    android.alert(res.message);
                }
            }).error(function () {
                android.showToast("出错");
            });
        }
    };

    $scope.gencode = function () {
        $http({
            url: $scope.data.reqUrl.gencode,
            method: "POST",
            data: {
                "phone": $scope.data.phone,
                "type": "2",
                "langcode": $scope.data.langcode
            },
            responseType: "json",
            timeout: 10000
        }).error(function () {
            android.showToast("出错");
        });
    }

    $scope.countdown = function () {
        this.data.isCountdown = true;
        var timer = $interval(function () {
            $scope.data.countdown--;
            if (!$scope.data.countdown) {
                $scope.data.countdown = 60;
                $scope.data.isCountdown = false;
            }
        }, 1000, 60)
    }

    $scope.checkPhone = function () {
        $http({
            url: $scope.data.reqUrl.checkverifycode,
            method: "POST",
            data: {
                "phone": $scope.data.phone,
                "code": $scope.data.code,
                "langcode": $scope.data.langcode
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                $scope.data.hrid = res.content.hrid;
                $scope.data.flag++;
            } else {
                android.alert(res.message);
            }
            $scope.data.commiting = false;
        }).error(function () {
            android.showToast("出错");
            $scope.data.commiting = false;
        });
    };
    $scope.checkPassword = function () {
        if (this.data.pw1 == "") {
            android.alert("不能为空");
            return;
        }
        if (this.data.pw1 != this.data.pw2) {
            android.alert("两次输入的密码不一样");
            return;
        }
        $http({
            url: $scope.data.reqUrl.changepw,
            method: "POST",
            data: {
                "hrid": $scope.data.hrid,
                "password": $scope.data.pw1,
                "langcode": $scope.data.langcode
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                android.showToast("修改成功");
                forgetApi.goback();
            } else {
                android.alert(res.message);
            }
            $scope.data.commiting = false;
        }).error(function () {
            android.showToast("出错");
            $scope.data.commiting = false;
        });
    };
    $scope.checkpeab = function () {
        $http({
            url: $scope.data.reqUrl.checkroleaccount,
            method: "POST",
            data: {
                "peab": $scope.data.peab,
                "roleaccount": $scope.data.account,
                "langcode": $scope.data.langcode
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                $scope.data.hrid = res.content.hrid;
                $scope.data.admin = res.content.ownerphone;
                $scope.data.admin1 = res.content.ownerphone.replace(/(\d{3})\d{4}(\d{4})/, "$1****$2");
                $scope.data.flag++;
            } else {
                android.alert(res.message);
            }
            $scope.data.commiting = false;
        }).error(function () {
            android.showToast("出错");
            $scope.data.commiting = false;
        });
    };
    $scope.checkAdmin = function () {
        if (this.data.admin2 != this.data.admin) {
            android.alert("号码错误");
            this.data.commiting = false;
            return;
        }
        $http({
            url: $scope.data.reqUrl.changepw,
            method: "POST",
            data: {
                "hrid": $scope.data.hrid,
                "ownerphone": $scope.data.admin2,
                "langcode": $scope.data.langcode
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                android.showToast("修改成功");
                forgetApi.goback();
            } else {
                android.alert(res.message);
            }
            $scope.data.commiting = false;
        }).error(function () {
            android.showToast("出错");
            $scope.data.commiting = false;
        });
    };
    $scope.back = function () {
        forgetApi.goback();
    };
});