var app = angular.module('myApp', ['component']);
app.controller('myCtrl', function ($scope, $http, $timeout) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("index_pageText")),
        'accountInfo': null,
        'warning_and_error': {
            'index_error': android.getString("index_error"),
            "network_unavailable": android.getString("network_unavailable"),
            "changepe_failed": android.getString("changepe_failed"),
            "getpelist_failed": android.getString("getpelist_failed"),
            "have_no_pe": android.getString("have_no_pe")
        },
        'prompt': {
            'changepe_succ': ""
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        'displayname': null,
        'thumb': '',
        'peDesc': '',
        'defaultThumb': "../../res/defaultlogo.png",
        'xj_count': null,
        'reqUrl': {
            'homePage': null,
            'checkUpdate': null,
            "homeList": null,
            "changepe": null,
            "checkexpire": null
        },
        'news': [],
        // 'fn_list': {
        //     'rcwo': {
        //         'icon': '../../res/icon/xjd.png',
        //         'text': "",
        //         'task_count': 0,
        //         'pageUrl': 'Rcwo'
        //     },
        //     'event': {
        //         'icon': '../../res/icon/report.png',
        //         'text': "",
        //         'task_count': 0,
        //         'pageUrl': 'EventList'
        //     },
        //     'statistic': {
        //         'icon': '../../res/icon/statistic.png',
        //         'text': "",
        //         'task_count': 0,
        //         'pageUrl': 'Statistic'
        //     },
        //     'task': {
        //         'icon': '../../res/icon/task.png',
        //         'text': '',
        //         'task_count': 0,
        //         'pageUrl': 'Rctask'
        //     },
        //     'notify': {
        //         'icon': '../../res/icon/announce.png',
        //         'text': '',
        //         'task_count': 0,
        //         'pageUrl': 'Notify'
        //     },
        //     'team': {
        //         'icon': '../../res/icon/team.png',
        //         'text': '',
        //         'task_count': 0,
        //         'pageUrl': 'Account'
        //     },
        //     'patrol': {
        //         'icon': '../../res/icon/nfc.png',
        //         'text': '',
        //         'task_count': 0,
        //         'pageUrl': 'NfcWriter'
        //     }
        // },
        'fn_list': {},
        "taskBoxUrl": "TaskBox",
        "noticeBoxUrl": "Notify",
        "serialnum": indexApi.getVerCode(),
        "changepe": {
            "list": [],
            "show": false,
            "cache": false,
            "currpe": null
        },
        "sliderid": "slider",
        "language": ""
    };
    $scope.init = function () {
        var lang = android.getsyslang();
        if (lang == "EN")
            this.data.sliderid = "sldierEng"

        this.data.accountInfo = JSON.parse(android.getAccountInfo());
        this.data.language = this.getLang();

        var pageText = this.data.pageText;
        var fn_list = [{
                'icon': '../../res/icon/xjd.png',
                'text': pageText.rcwo,
                'task_count': 0,
                'pageUrl': 'Rcwo'
            },
            {
                'icon': '../../res/icon/report.png',
                'text': pageText.event_report,
                'task_count': 0,
                'pageUrl': 'EventList'
            },
            {
                'icon': '../../res/icon/statistic.png',
                'text': pageText.statistic,
                'task_count': 0,
                'pageUrl': 'Statistic'
            },
            {
                'icon': '../../res/icon/task.png',
                'text': pageText.task,
                'task_count': 0,
                'pageUrl': 'Rctask'
            },
            {
                'icon': '../../res/icon/announce.png',
                'text': pageText.notify,
                'task_count': 0,
                'pageUrl': 'Notify'
            },
            {
                'icon': '../../res/icon/team.png',
                'text': pageText.team,
                'task_count': 0,
                'pageUrl': 'Account'
            }
        ];
        // fn_list.rcwo.text = pageText.rcwo, fn_list.event.text = pageText.event_report, fn_list.statistic.text = pageText.statistic, fn_list.task.text = pageText.task, fn_list.notify.text = pageText.notify, fn_list.team.text = pageText.team, fn_list.patrol.text = pageText.patrol;

        if (this.data.accountInfo.ispemgr == '1')
            fn_list.push({
                'icon': '../../res/icon/nfc.png',
                'text': pageText.patrol,
                'task_count': 0,
                'pageUrl': 'NfcWriter'
            }, {
                'icon': '../../res/icon/bluetooth.png',
                'text': pageText.ble_bind,
                'task_count': 0,
                'pageUrl': 'BLEBind'
            });
        this.data.fn_list = fn_list;

        this.data.peIsNull = !Boolean(this.data.accountInfo.penum);
        this.data.reqUrl.homePage = android.getReqUrl("index");
        this.data.reqUrl.checkUpdate = android.getReqUrl("appversion");
        this.data.reqUrl.homeList = android.getReqUrl("homelist");
        this.data.reqUrl.changepe = android.getReqUrl("changepe");
        this.data.reqUrl.checkexpire = android.getReqUrl("checkexpire");

        indexApi.isnotifyon();
        this.checkUpdate();

        if (!this.data.peIsNull) {
            this.data.changepe.currpe = this.data.accountInfo.penum;

            var totalJson = JSON.parse(indexApi.getTotal(this.data.accountInfo.hrid, this.data.accountInfo.penum));
            this.data.xj_count = totalJson.taskTotal;
            this.data.fn_list[1].task_count = totalJson.eventReportTotal;
            var offLineData = JSON.parse(indexApi.getOffLineData());
            this.data.peDesc = offLineData.peDesc;
            this.data.thumb = offLineData.thumb;
            this.data.displayName = offLineData.displayName;
        }
        this.refresh();
    };
    $scope.getLang = function () {
        // var lang = android.getsyslang();
        var lang = android.getsyslang() == "EN" ? "-en" : "";
        return android.getsyslang() == "EN" ? "-en" : "";
        // switch (lang) {
        //     case "ZH":
        //         return "";
        //     case "EN":
        //         return "en";
        //     case "ZHT":
        //         return "tc"
        // }
    }
    $scope.peIsNull = function () {
        if (this.data.peIsNull) {
            android.alert(this.data.warning_and_error.have_no_pe);
            return true
        }
        return false;
    }
    $scope.isNetworkAvailable = function () {
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            return true;
        } else {
            android.refreshComplete();
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }
    $scope.refresh = function (type) {
        this.data.changepe.cache = false;
        if (this.peIsNull()) return;
        var data = $scope.data;
        if (this.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            $http({
                url: data.reqUrl.homePage,
                method: "POST",
                data: data.accountInfo,
                responseType: "json",
                timeout: 10000
            }).success(function (res) {
                if (res.success) {
                    var content = res.content;
                    data.thumb = content.pelogourl;
                    $timeout(function () {
                        indexApi.saveThumb(content.pelogourl);
                    }, 0);
                    indexApi.savePeDesc(content.description);
                    indexApi.saveDisplayName(content.displayname);
                    indexApi.saveIspemgr(content.ispemgr);
                    data.displayName = content.displayname;
                    data.peDesc = content.description;
                    // data.accountInfo.selfregister = content.selfregister;
                    if (content.ispemgr == '1' && content.ispemgr != $scope.data.accountInfo.ispemgr) {
                        $scope.data.fn_list.push({
                            'icon': '../../res/icon/nfc.png',
                            'text': $scope.data.pageText.patrol,
                            'task_count': 0,
                            'pageUrl': 'NfcWriter'
                        }, {
                            'icon': '../../res/icon/bluetooth.png',
                            'text': $scope.data.pageText.ble_bind,
                            'task_count': 0,
                            'pageUrl': 'BLEBind'
                        });
                        $scope.data.accountInfo.ispemgr = content.ispemgr;
                    }
                    if (content.wocount) data.xj_count = content.wocount;
                    else data.xj_count = 0;
                    if (content.news.length > 1) {
                        content.news.push(content.news[0]);
                    }
                    data.news = content.news;
                } else {
                    android.alert(res.message);
                }
                android.refreshComplete();
            }).error(function () {
                android.refreshComplete();
                android.showToast($scope.data.warning_and_error.index_error);
            });
        }
    };
    $scope.getHomeList = function () {
        if (this.peIsNull()) return;
        if (this.data.accountInfo.selfregister == "Y") {
            android.setRefreshDisable();
            indexApi.setHomeListShow();
            if (this.data.changepe.cache) {
                if (this.data.changepe.list.length > 1)
                    this.data.changepe.show = true;
            } else {
                $http({
                    url: $scope.data.reqUrl.homeList,
                    method: "POST",
                    data: $scope.data.accountInfo,
                    responseType: "json",
                    timeout: 1000
                }).success(function (res) {
                    if (res.success) {
                        var len = res.total;
                        if (len) {
                            $scope.data.changepe.cache = true;
                            $scope.data.changepe.list = res.content.map(function (item) {
                                return {
                                    name: item.description,
                                    value: item.penum
                                };
                            });
                            if (len > 1 || !$scope.data.changepe.currpe)
                                $scope.data.changepe.show = true;
                        }
                    }
                })
            }
        }
    };
    $scope.changepe = function (newPenum) {
        this.data.accountInfo.penum = newPenum;
        if (this.isNetworkAvailable()) {
            this.refresh();
            $http({
                url: $scope.data.reqUrl.changepe,
                method: "POST",
                data: {
                    hrid: $scope.data.accountInfo.hrid,
                    penum: newPenum
                },
                responseType: "json",
                timeout: 1000
            }).success(function (res) {
                if (res.success) {
                    if (!$scope.data.prompt.changepe_succ)
                        $scope.data.prompt.changepe_succ = android.getString("changepe_success");
                    // $scope.data.accountInfo.penum = newPenum;
                    // $scope.refresh();
                    // indexApi.changepe(newPenum);
                    android.showToast($scope.data.prompt.changepe_succ);
                } else {
                    android.showToast(res.message);
                    $scope.data.changepe.currpe = $scope.data.accountInfo.penum;
                }
            }).error(function () {
                android.showToast($scope.data.warning_and_error.changepe_failed);
            })
        }
    }
    $scope.$watch("data.changepe.currpe", function (newVal, oldVal) {
        if (newVal != oldVal && $scope.data.changepe.show) {
            $scope.hideMulteseBox();
            indexApi.changepe(newVal);
            $scope.changepe(newVal);
        }
    });
    $scope.$watch("data.changepe.show", function (newVal) {
        if (!newVal)
            android.setRefreshEnabled();
    })
    $scope.hideMulteseBox = function () {
        this.data.changepe.show = false;
        android.setRefreshEnabled();
    }
    $scope.showNotification = function (e, notifynum) {
        e.stopPropagation();
        indexApi.showNotification(notifynum);
    };
    $scope.checkUpdate = function () {
        if (indexApi.hadChecked(this.data.accountInfo.hrid, this.data.accountInfo.penum)) {
            return;
        }
        if (!android.isNetworkAvailable()) {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        } else {
            this.data.warnData.showWarn = false;
            $http({
                url: $scope.data.reqUrl.checkUpdate,
                method: "POST",
                data: {
                    "hrid": $scope.data.accountInfo.hrid,
                    "appname": "313FM",
                    "serialnum": $scope.data.serialnum
                },
                responseType: "json",
                timeout: 10000
            }).success(function (res) {
                if (res.success)
                    indexApi.update(res.content.url, res.content.version);
            })
        }
    }
    $scope.loadUrl = function ($e, pageUrl) {
        $e.preventDefault();
        if (this.peIsNull()) return;
        indexApi.openUrlForResult(pageUrl);
    };

    $scope.setting = function () {
        indexApi.openAct("Setting");
    };

    $scope.checkExpire = function ($e) {
        // 检查该账号的服务是否到期
        $e.preventDefault();
        if (this.peIsNull()) return;
        if (android.isNetworkAvailable()) {
            android.setRefresh();
            $http({
                url: $scope.data.reqUrl.checkexpire,
                method: "POST",
                data: {
                    hrid: $scope.data.accountInfo.hrid,
                    penum: $scope.data.accountInfo.penum
                },
                responseType: "json",
                timeout: 10000
            }).success(function (res) {
                // console.log(JSON.stringify({
                //     hrid: $scope.data.accountInfo.hrid,
                //     penum: $scope.data.accountInfo.penum
                // }, "", 2));
                // console.log(JSON.stringify(res, "", 2));
                if (res.success) {
                    indexApi.openUrlForResult($scope.data.taskBoxUrl);
                } else {
                    android.alert(res.message);
                }
                android.refreshComplete();
            }).error(function() {
                android.refreshComplete();
            })
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
            return;
        }
    }
});

app.component("slideFollow", {
    bindings: {
        id: "@containerid",
        news: "<",
        clickfn: "&itemclickfn",
        parentid: "@"
    },
    template: '<div class="slider"><div ng-repeat="(key, value) in $ctrl.news track by $index" class="msg_box align_item_center" ng-click="$ctrl.clickfn({e:$event, notifynum:value.notifynum})"><div class="msg">{{value.title}}</div></div></div>',
    controller: function controller($scope, $timeout, $interval) {
        this.interval = null;
        this.i = 0;
        var ctrl = this;
        this.$onChanges = function (changesObj) {
            $interval.cancel(this.interval);
            this.init();
        };

        this.init = function () {
            this.container = $(this.id);
            this.containerHeight = $(this.parentid).height();
            this.container.css({
                "height": this.containerHeight + "px"
            });
            var slider = this.container.find(".slider");
            var sliderEle = slider[0];
            slider.children().css({
                "height": this.containerHeight + "px",
                "line-height": this.containerHeight + "px"
            });
            var divLength = slider.children().length - 1;
            if (divLength < 1) return;

            this.interval = $interval(function () {
                ctrl.slide(sliderEle, $scope.$ctrl.containerHeight, divLength);
            }, 3000);
        };

        this.slide = function (sliderEle, containerHeight, divLength) {
            if (!this.i) {
                sliderEle.className = sliderEle.className.replace(" transition_unset", "");
            }
            this.i++;
            sliderEle.style.transform = "translate3d(0,-" + this.i * containerHeight + "px,0)";
            sliderEle.style.webkitTransform = "translate3d(0,-" + this.i * containerHeight + "px,0)";
            if (this.i == divLength) {
                this.i = 0;
                $timeout(function () {
                    sliderEle.className += " transition_unset";
                    sliderEle.style.transform = "translate3d(0,0,0)";
                    sliderEle.style.webkitTransform = "translate3d(0,0,0)";
                }, 1000);
            }
        };
    }
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    });
}

function refreshTotal() {
    angularApply(function () {
        var totalJson = JSON.parse(indexApi.getTotal(scope.data.accountInfo.hrid, scope.data.accountInfo.penum));

        if (totalJson.taskTotal)
            scope.data.xj_count = totalJson.taskTotal
        else
            scope.refresh();
        scope.data.fn_list[1].task_count = totalJson.eventReportTotal;
    });
}

function hideMulteseBox() {
    angularApply(function () {
        scope.hideMulteseBox();
    })
}