var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http, $focus) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("login_pageText")),
        "type": "",
        "type_group": {
            "account": "account",
            "mobile": "mobile"
        },
        "loginInfo": {
            "peab": null,
            "roleaccount": null,
            "phone": null,
            "password": null,
            "langcode": loginApi.getsyslang()
        },
        "logining": false,
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "warning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "login_error": android.getString("login_error"),
            "input_pw": android.getString("input_pw"),
            "pw_len": android.getString("pw_len"),
            "input_peba": android.getString("input_peba"),
            "input_roleaccount": android.getString("input_roleaccount"),
            "mobile_num_error": android.getString("mobile_num_error")
        },
        "postData": null,
        "accountInfo": null,
        "isSetServer": false,
        "serverAdd": ""
    };

    $scope.init = function () {
        this.data.type = this.data.type_group.account;
        var loginInfo = loginApi.getLoginInfo();
        if (loginInfo) {
            var loginInfoJson = JSON.parse(loginInfo);
            this.data.loginInfo.peab = loginInfoJson.peab;
            this.data.loginInfo.roleaccount = loginInfoJson.roleaccount;
            this.data.loginInfo.phone = loginInfoJson.phone;
            if (loginInfoJson.phone) {
                this.data.type = this.data.type_group.mobile;
            }
        }
        if (!android.isNetworkAvailable()) {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }

    $scope.changeType = function (type) {
        this.data.loginInfo.peab = "";
        this.data.loginInfo.roleaccount = "";
        this.data.loginInfo.phone = "";
        this.data.loginInfo.password = "";
        this.data.type = type;
    }

    $scope.checkInfo = function () {
        if (!this.data.loginInfo.password) {
            android.alert(this.data.warning_and_error.input_pw);
            return false;
        } else if (this.data.loginInfo.password.length < 6) {
            android.alert(this.data.warning_and_error.pw_len);
            return false;
        }
        if (this.data.type == this.data.type_group.account) {
            if (!this.data.loginInfo.peab) {
                android.alert(this.data.warning_and_error.input_peba);
                return false;
            }
            if (!this.data.loginInfo.roleaccount) {
                android.alert(this.data.warning_and_error.input_roleaccount);
                return false;
            }
            return {
                "peab": this.data.loginInfo.peab,
                "roleaccount": this.data.loginInfo.roleaccount,
                "password": this.data.loginInfo.password,
                "langcode": "ZH"
            };
        } else if (this.data.type == this.data.type_group.mobile) {
            // if (!/^1[3-8]\d{9}$|^[5689]\d{7}$|^09\d{8}$|^6[86]\d{5}$/.test(this.data.loginInfo.phone)) {
            //     android.alert(this.data.warning_and_error.mobile_num_error);
            //     return false;
            // }
            return {
                "phone": this.data.loginInfo.phone,
                "password": this.data.loginInfo.password
            };
        }
    };

    $scope.login = function () {
        if (!android.isNetworkAvailable()) {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString(network_unavailable);
            return false;
        } else {
            this.data.warnData.showWarn = false;
        }
        var postData = this.checkInfo();
        if (postData) {
            this.data.logining = true;
            $http({
                url: android.getReqUrl("login"),
                method: "POST",
                data: postData,
                responseType: "json",
                timeout: 10000
            }).success(function (res) {
                console.log(JSON.stringify(res, "", 2));
                if (res.success) {
                    if (res.content.expire) {
                        $scope.data.postData = postData;
                        $scope.data.accountInfo = res.content;
                        android.dialog("", res.content.expire, "storageLoginInfo()");
                    } else loginApi.storageLoginInfo(JSON.stringify(res.content), JSON.stringify(postData));
                } else {
                    android.alert(res.message);
                }
                $scope.data.logining = false;
            }).error(function (res) {
                console.log(JSON.stringify(res, "", 2));
                $scope.data.logining = false;
                android.showToast($scope.data.warning_and_error.login_error);
            });
        }
    }

    $scope.forget = function () {
        loginApi.openForgetAct(this.data.type);
    }

    $scope.storageLoginInfo = function () {
        loginApi.storageLoginInfo(JSON.stringify(this.data.accountInfo), JSON.stringify(this.data.postData));
    }

    $scope.setServer = function () {
        loginApi.setServer(this.data.serverAdd);
        this.setIsSetServer(false);
    }

    $scope.getCurrServer = function () {
        this.data.serverAdd = loginApi.getCurrServer();
    }

    $scope.setIsSetServer = function (isSetServer) {
        if (isSetServer) this.getCurrServer();
        this.data.isSetServer = isSetServer;
        loginApi.setIsSetServer(isSetServer);
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function storageLoginInfo() {
    angularApply(function () {
        scope.storageLoginInfo();
    })
}

function setIsSetServer(isSetServer) {
    angularApply(function () {
        scope.setIsSetServer(isSetServer);
    })
}