$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});

var app = angular.module('myApp', ['component']);
app.controller('myCtrl', function ($scope, $http, $focus) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("nfcWriter_pageText")),
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "reqUrl": android.getReqUrl("locList"),
        "header": {
            "title": android.getString("title_nfcwriter"),
            "backtext": android.getString("back")
        },
        "warning_and_error": {
            "index_error": android.getString("index_error"),
            "network_unavailable": android.getString("network_unavailable"),
        },
        "currentLocName": "",
        "nfcContent": "",
        "searching": false,
        "searchbar": {
            "searchText": "",
            "focus": true,
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "locList": {
            "unfinishedList": [],
            "finishedList": []
        },
        "flag": true
    }
    $scope.init = function () {
        if (nfcWriterApi.getLocTotal(this.data.accountInfo.penum) == 0) {
            this.refresh();
        } else {
            var locList = JSON.parse(nfcWriterApi.getLocList(this.data.accountInfo.penum));
            this.data.locList.unfinishedList = locList.unfinishedList;
            this.data.locList.finishedList = locList.finishedList;
        }
    }
    $scope.beforeRefresh = function () {
        android.dialog(android.getString("confirm_to_reset_location"), "", "refresh()", "");
    }
    $scope.refresh = function () {
        if (android.isNetworkAvailable()) {
            this.updateLocList();
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
        }
    }
    $scope.updateLocList = function () {
        android.setRefresh();
        $http({
            url: $scope.data.reqUrl,
            data: JSON.stringify({
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "pagesize": 2000,
                "active":"1",
                "labeltype":"NFC"
            }),
            method: "post",
            responseType: "json",
            timeout: 20000
        }).success(function (res) {
            if (res.success) {
                nfcWriterApi.updateLocList($scope.data.accountInfo.penum, JSON.stringify(res.content)); // 更新本地巡更点
                $scope.data.locList = JSON.parse(nfcWriterApi.getLocList($scope.data.accountInfo.penum)); // 从本地数据库中获取巡更点
                android.showToast(android.getString("refreshComplete"));
            } else
                android.alert(res.message);
            android.refreshComplete();
        }).error(function () {
            android.refreshComplete();
            android.alert($scope.data.warning_and_error.index_error);
        })
    }
    $scope.back = function () {
        nfcWriterApi.goback();
    }
    $scope.clear = function () {
        this.data.currentLocName = "";
        this.data.nfcContent = "";
        this.data.searchbar.searchText = "";
        nfcWriterApi.setLoc("");
    }
    $scope.setSearching = function (isSearching) {
        this.data.searching = isSearching;
        if (this.data.flag)
            $focus("searchInput");
        nfcWriterApi.setSearching(isSearching);
        this.data.searching = isSearching;
    }
    $scope.clickLoc = function (loc) {
        // if (finished)
        //     var temList = this.data.locList.finishedList;
        // else
        //     var temList = this.data.locList.unfinishedList;
        // for (var i = 0, len = temList.length; i < len; i++) {
        //     if (temList[i].value == loc)
        //         this.data.currentLocName = temList[i].name;
        // }
        this.data.currentLocName = loc.name;
        nfcWriterApi.setLoc(loc.value);
        this.setSearching(false);
        this.data.searchbar.searchText = "";
        this.data.nfcContent = "";
    }
    $scope.finishedLoc = function (loc) {
        var temLoc;
        var temUnfinishedList = this.data.locList.unfinishedList;
        this.data.currentLocName = "";
        nfcWriterApi.setLoc("");
        for (var i = 0, len = temUnfinishedList.length; i < len; i++) {
            if (temUnfinishedList[i].value == loc) {
                // nfcWriterApi.finishedLoc(loc);
                temLoc = (temUnfinishedList.splice(i, 1))[0];
                this.data.locList.finishedList.push(temLoc);
                break;
            }
        }
        this.data.currentLocName = "";
        nfcWriterApi.setLoc("");
    }
    $scope.changeNfcContent = function (currentLoc) {
        this.data.nfcContent = currentLoc;
    }
});
app.filter("locFilter", function () {
    return function (locList, condition) {
        if (condition) {
            return locList.filter(function (loc) {
                return loc.name.toLocaleLowerCase().indexOf(condition.toLocaleLowerCase()) > -1
            })
        } else return locList;
    }
});
app.factory("$focus", function ($timeout, $window) {
    return function (id) {
        $timeout(function () {
            var element = $window.document.getElementById(id);
            if (element) element.focus();
        });
    };
});
app.component("searchtool", {
    template: '<div class="ui-searchbar-wrap {{$ctrl.searchbar.focus?\'focus\':\'\'}}"><div class="ui-searchbar ui-border-radius" ng-click="$ctrl.focus()"><i class="ui-icon-search"></i><div class="ui-searchbar-text">{{$ctrl.searchbar.placeholder}}</div><div class="ui-searchbar-input"><input value="" type="text" placeholder="{{$ctrl.searchbar.placeholder}}"autocapitalize="off" ng-model="$ctrl.searchbar.searchText" id="searchInput"></div><i class="ui-icon-close" ng-click="$ctrl.clear()"></i></div></div>',
    bindings: {
        searchbar: "=",
        scan: "&",
        characteristic: "="
    },
    controller: function controller($scope, $focus) {
        var _this = this;
        this.focus = function () {
            this.searchbar.focus = true;
            $focus("searchInput");
        };

        this.clear = function () {
            this.searchbar.searchText = "";
            $focus("searchInput");
        };

        this.cancel = function () {
            this.searchbar.searchText = "";
            this.searchbar.focus = false;
        };

        this.preScan = function (characteristic) {
            if (characteristic != undefined) {
                this.characteristic = characteristic;
                this.scan({
                    characteristic: characteristic
                });
            } else {
                this.scan();
            }
        };

        $scope.$watch("$ctrl.searchbar.searchText", function (newVal) {
            if (newVal) {
                _this.searchbar.focus = true;
            }
        });
    }
})
app.component("myHeaderP", {
    template: "<header class='ui-header ui-header-positive'><div ng-click='$ctrl.back()'><i class='ui-icon-return'></i><div class='reback'>{{$ctrl.backtext}}</div></div><h1>{{$ctrl.title}}</h1><div class='right-item' ng-click='$ctrl.refresh()'><div></div><i class='ui-icon-refresh'></i></div></header>",
    bindings: {
        back: "&",
        title: "<",
        backtext: "<",
        refresh: "&"
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function changeNfcContent(currentLoc) {
    angularApply(function () {
        scope.changeNfcContent(currentLoc);
    })
}

function setSearching() {
    angularApply(function () {
        scope.setSearching(false);
    })
}

function finishedLoc(loc) {
    angularApply(function () {
        scope.data.currentLocName = "";
        scope.finishedLoc(loc);
    })
}

function refresh() {
    angularApply(function () {
        scope.refresh();
    })
}