var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("createNotification_pageText")),
        "header": {
            "title": android.getString("title_createNotification"),
            "backtext": android.getString('back')
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": null
        },
        "warning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "createnotification_error": android.getString("createnotification_error"),
            "input_createnotification_title": android.getString("input_createnotification_title"),
            "input_createnotification_content": android.getString("input_createnotification_content"),
            "input_noticescope": android.getString("input_noticescope"),
            "notification_commit_success": android.getString("notification_commit_success")
        },
        "reqUrl": android.getReqUrl("createnotification"),
        "notificationData": {
            "title": "",
            "description": "",
            "notifyall": "",
            "noticescope": []
        },
        "noticescope": [],
        "notifyall": false,
        "change": false,
        "loading": false
    }
    $scope.$watch("data.notifyall", function (newVal, oldVal) {
        if (newVal)
            $scope.data.notificationData.notifyall = "1";
        else
            $scope.data.notificationData.notifyall = "0";
    });
    $scope.$watch("data.notificationData", function (newVal, oldVal) {
        if (newVal == oldVal)
            $scope.data.change = false;
        else
            $scope.data.change = true;
    }, true);
    $scope.init = function () {

    }
    $scope.back = function () {
        createNotificationApi.dialog("", android.getString("confirm_to_quit"));
    }
    $scope.addNoticescope = function () {
        if (this.data.notifyall)
            return;
        createNotificationApi.query(JSON.stringify(this.data.noticescope));
    }
    $scope.showNoticescope = function () {
        createNotificationApi.setishow();
        this.data.show = true;
    }
    $scope.hideNoticescope = function () {
        this.data.show = false;
    }
    $scope.clear = function (e) {
        e.stopPropagation();
        this.data.noticescope = [];
    }
    $scope.removeItem = function (e, index) {
        e.stopPropagation();
        this.data.noticescope.splice(index, 1);
    }
    $scope.commit = function () {
        if (!android.isNetworkAvailable()) {
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
            this.data.warnData.showWarn = true;
        } else {
            var postData = this.checkData();
            if (postData) {
                $scope.data.loading = true;
                var accountInfo = JSON.parse(android.getAccountInfo());
                postData.hrid = accountInfo.hrid;
                postData.penum = accountInfo.penum;
                if (this.data.notifyall) {
                    postData.notifyall = "1"
                } else {
                    postData.notifyall = "0";
                }
                postData.noticescope = this.data.noticescope.map(function (item) {
                    var account = {
                        "hrid": item.id
                    };
                    return account;
                });
                $http({
                    url: $scope.data.reqUrl,
                    data: postData,
                    method: "POST",
                    responseType: "json"
                }).success(function (res) {
                    if (res.success) {
                        android.showToast($scope.data.warning_and_error.notification_commit_success);
                    } else
                        android.alert(res.message);
                    $scope.data.loading = false;
                    createNotificationApi.goback();
                }).error(function () {
                    $scope.data.loading = false;
                    android.alert($scope.data.warning_and_error.createnotification_error);
                })
            }
        }
    }
    $scope.checkData = function () {
        if (this.form.title.$error.required) {
            android.alert(this.data.warning_and_error.input_createnotification_title);
            return false;
        }
        if (this.form.content.$error.required) {
            android.alert(this.data.warning_and_error.input_createnotification_content);
            return false;
        }
        if (!this.data.notifyall && !this.data.noticescope.length) {
            android.alert(this.data.warning_and_error.input_noticescope);
            return false;
        }
        return this.data.notificationData;
    }
})


function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function back() {
    angularApply(function () {
        scope.back();
    })
}

function getNoticescope() {
    angularApply(function () {
        scope.data.noticescope = JSON.parse(createNotificationApi.getNoticescope());
    })
}

function closeNoticeScope() {
    angularApply(function () {
        scope.hideNoticescope();
    })
}