$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});

var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("rctaskDetail_pageText")),
        "header": {
            "title": android.getString("title_rcwotaskdetail"),
            "backtext": android.getString("back")
        },
        "reqUrl": {
            "taskdetail": android.getReqUrl("taskdetail"),
            "rcwofortask": android.getReqUrl("rcwofortask")
        },
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "tasknum": null,
        "detail": {},
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "warning_and_error": {
            "rcwotask_error": android.getString("rcwotask_error")
        },
        "frequnit": {
            "MINUTE": android.getString("MINUTE"),
            "HOUR": android.getString("HOUR"),
            "DAY": android.getString("DAY"),
            "WEEK": android.getString("WEEK"),
            "MONTH": android.getString("MONTH"),
            "YEAR": android.getString("YEAR")
        },
        "showdetail": false,
        "loadMore": {
            "loading": false,
            "text": ""
        },
        "more": true,
        "pageConfig": {
            "page": 1,
            "pageSize": 5
        },
        "rcwolist": [],
        "warnData": {
            "showWarn": false,
            "warnMsg": android.getString("network_unavailable")
        },
        "reqStatus": {
            "detail": true,
            "rcwo": true
        },
        "multiSelectBox": {
            "show": false,
            "currVal": 0,
            "arr": [],
            "target": null,
            "currLoc": null
        },
        "chartObj": {
            "pie": null,
            "bar": null
        },
        "chartData": {
            "compcount": 0,
            "tocount": 0,
            "overtimecount": 0,
            "cancount": 0,
            "totalcount": 0,
            "datalist": []
        },
        "lang": android.getsyslang(),
        "interval": 0,
        "suffix": "",
        "unitList": []
    };
    $scope.init = function () {
        var pageData = JSON.parse(rctaskApi.getPageData());
        this.data.tasknum = pageData.tasknum;
        // this.data.header.title = pageData.tasknum;
        this.refresh();
    };
    $scope.refresh = function () {
        if (this.isNetworkAvailable()) {
            android.setRefresh();
            this.data.more = true;
            this.data.pageConfig.page = 1;
            this.getDetail();
            this.getRcwo(true);
            // this.getUnitList();
        }
    }
    $scope.isNetworkAvailable = function () {
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            return true;
        } else {
            this.data.warnData.showWarn = true;
            return false;
        }
    }
    $scope.getDetail = function () {
        this.data.reqStatus.detail = false;
        var _this = this;
        $http({
            url: $scope.data.reqUrl.taskdetail,
            data: JSON.stringify({
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "tasknum": $scope.data.tasknum
            }),
            method: "post",
            response: "json"
        }).success(function (res) {
            if (res.success) {
                res.content.frequnit = $scope.data.frequnit[res.content.frequnit];
                if ($scope.isTomorrow(res.content.activefrom, res.content.activeto)) res.content.activeto = android.getString("tomorrow") + res.content.activeto;
                _this.data.detail = res.content;
                if(_this.data.detail.interval)
                    _this.data.interval = 1 + parseInt(_this.data.detail.interval);
                if (_this.data.lang == "EN") {
                    var suffix = "";
                    switch (_this.data.interval) {
                        case 2:
                            suffix = "nd";
                            break;
                        case 3:
                            suffix = "rd";
                            break;
                        default:
                            suffix = "th";
                            break;
                    }
                    _this.data.suffix = "(" + suffix + ")";
                }

                $scope.statistics(res.content);
            } else {
                android.alert(res.message);
            }
            _this.data.reqStatus.detail = true;
            _this.checkReqStatus();
        }).error(function () {
            android.showToast($scope.data.warning_and_error.rcwotask_error);
            _this.data.reqStatus.detail = true;
            _this.checkReqStatus();
        });
    };
    $scope.getRcwo = function (isrefresh) {
        var _this = this;
        this.data.reqStatus.rcwo = false;
        this.data.loadMore.text = this.data.pageText.loading;
        $http({
            url: $scope.data.reqUrl.rcwofortask,
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "tasknum": $scope.data.tasknum,
                "page": _this.data.pageConfig.page,
                "pagesize": _this.data.pageConfig.pageSize
            },
            method: "post",
            response: "json"
        }).success(function (res) {
            if (res.success) {
                if (isrefresh) {
                    _this.data.rcwolist = res.content;
                } else {
                    _this.data.rcwolist = _this.data.rcwolist.concat(res.content);
                }
                _this.data.loadMore.loading = false;
                if (_this.data.pageConfig.pageSize > res.total) {
                    _this.data.loadMore.text = _this.data.pageText.nomore;
                    _this.data.more = false;
                } else {
                    _this.data.pageConfig.page++;
                    _this.data.loadMore.text = _this.data.pageText.loadmore;
                }
                _this.data.reqStatus.rcwo = true;
                _this.checkReqStatus();
            }
        }).error(function () {
            _this.data.reqStatus.rcwo = true;
            _this.checkReqStatus();
        });
    }
    $scope.isTomorrow = function (from, to) {
        var reg = /\-/g;
        var temForm = from.replace(reg, ""),
            temTo = to.replace(reg, "");
        if (parseInt(temForm) < parseInt(temTo)) return false;
        else return true;
    };
    $scope.rcwolistLoadMore = function () {
        if (this.data.loadMore.loading || !this.data.more) {
            return;
        }
        if (this.isNetworkAvailable()) {
            this.getRcwo();
        }
    }
    $scope.checkReqStatus = function () {
        if (this.data.reqStatus.detail && this.data.reqStatus.rcwo) {
            android.refreshComplete();
        }
    }
    $scope.openLoc = function (item) {
        rctaskApi.openLoc(JSON.stringify(item));
    };
    $scope.showdetail = function () {
        this.data.showdetail = !this.data.showdetail;
    }
    $scope.back = function () {
        rctaskApi.goback();
    };
    $scope.multiSelect = function (item) {
        if (this.data.multiSelectBox.currLoc != item.location) {
            if (!item.multiSelectList) {
                item.multiSelectList = [];
                if(item.inputtype == "EITHEROR")
                item.multiSelectList.push({
                    name: item.option1
                }, {
                    name: item.option2
                });
                else if (item.inputtype == "MULTISELECT") {
                    item.selectlistval.forEach(function(option) {
                        item.multiSelectList.push({
                            name: option
                        })
                    });
                }
            }
            this.data.multiSelectBox.arr = item.multiSelectList;
        }
        this.data.multiSelectBox.show = true;
        rctaskApi.setishow();
    }
    $scope.rcwoDetail = function (wonum) {
        android.openActWithData("rcwo.Rcwohistory", wonum);
    }
    $scope.statistics = function (content) {
        this.data.chartData.compcount = parseInt(content.rcwocomp);
        this.data.chartData.tocount = parseInt(content.rcwoto);
        this.data.chartData.overtimecount = parseInt(content.rcwoovertime);
        this.data.chartData.cancount = parseInt(content.rcwocan);
        this.data.chartData.totalcount = parseInt(content.rcwocount);
        this.data.chartData.datalist = [{
            description:this.data.pageText.cmpontime,
            total: content.rcwocomp,
            color: "#29c98b"
        },{
            description:this.data.pageText.cmpovrdue,
            total: content.rcwoto,
            color: "#7cc8f8"
        },{
            description:this.data.pageText.notfollow,
            total: content.rcwoto,
            color: "#ff5a5a"
        },{
            description:this.data.pageText.cancelled,
            total: content.rcwocan,
            color: "#ddd"
        },{
            description:this.data.pageText.total,
            total: content.rcwocount,
            color: "#ffa100"
        }];
        this.createPieChart();
        this.createBarChart();
    };
    $scope.createPieChart = function () {
        //饼图
        if (this.data.chartObj.pie) {
            var pieChart = this.data.chartObj.pie;
        } else {
            var pieChart = echarts.init(document.getElementById('pie'), null, {
                "renderer": "svg"
            });
            this.data.chartObj.pie = pieChart;
        }
        var colorlist = [];
        var desclist = [];
        var datalist = [];
        this.data.chartData.datalist.slice(0, -1).forEach(function (element) {
            desclist.push(element.description);
            datalist.push({
                value: element.total,
                name: element.description
            });
            colorlist.push(element.color);
        });
        var option = {
            tooltip: {
                formatter: "{b} : {c} ({d}%)"
            },
            legend: {
                y: 'top',
                x: 'left',
                data: desclist
            },
            series: [{
                type: 'pie',
                radius: '55%',
                center: ['50%', '60%'],
                data: datalist,
            }],
            color: colorlist
        };
        pieChart.resize();
        pieChart.setOption(option, true);
    };
    $scope.createBarChart = function () {
        //柱状图
        if (this.data.chartObj.bar) {
            var barChart = this.data.chartObj.bar;
        } else {
            var barChart = echarts.init(document.getElementById('bar')); //初始化echarts实例
            this.data.chartObj.bar = barChart;
        }
        var desclist = [];
        var datalist = [];
        var colorlist = [];
        this.data.chartData.datalist.forEach(function (element) {
            desclist.push({
                value: element.description,
                textStyle: {
                    fontsize: 12
                }
            });
            datalist.push(element.total);
            colorlist.push(element.color);
        });
        var option = {
            title: {
                text: '',
                subtext: ''
            },
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'shadow'
                }
            },
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true
            },
            xAxis: {
                type: 'category',
                data: desclist,
                axisLabel: {
                    interval: 0
                }
            },
            yAxis: {
                show: true,
                type: 'value'
            },
            series: [{
                name: '单数',
                type: 'bar',
                itemStyle: {
                    normal: {
                        color: function color(params) {
                            return colorlist[params.dataIndex];
                        }
                    }
                },
                label: {
                    show: true,
                    position: 'top',
                    formatter: '{c}',
                    textStyle: {
                        fontsize: 12
                    }
                },
                data: datalist
            }]
        };
        barChart.resize();
        barChart.setOption(option, true);
    };

});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    })
}

function closeMask() {
    angularApply(function () {
        scope.data.multiSelectBox.show = false;
    })
}