$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});

var app = angular.module('myApp', ['component', 'loadMore']);
app.controller("myCtrl", function ($scope, $http) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("rcwo_pageText")),
        "accountInfo": null,
        "query": null,
        "reqUrl": android.getReqUrl("rcwolist"),
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "warning_and_error": {
            "rcwolist_error": android.getString("rcwolist_error"),
            "rcwohistory_error": android.getString("rcwohistory_error"),
        },
        "header": {
            "title": android.getString("title_rcwo"),
            "backtext": android.getString("back")
        },
        "rcwolist": {
            "finished": {
                "total": null,
                "list": []
            },
            "unfinished": {
                "total": null,
                "list": []
            }
        },
        "rcwostatu": {
            "needToSync": 0,
            "needToDeal": 0
        },
        "refreshStatus": {
            "finishedList": true,
            "unfinishedList": true
        },
        "pullToLoadMore": {
            "finished": {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            },
            "unfinished": {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            }
        },
        "more": {
            "finished": true,
            "unfinished": true
        },
        "myListConfig": {
            "unfinished": {
                "page": 1,
                "pagesize": 20
            },
            "finished": {
                "isme": "0",
                "page": 1,
                "pagesize": 20
            }
        },
        "searchbar": {
            "searchText": "",
            "focus": false,
            "placeholder": "",
            "button": ""
        }
    };
    $scope.init = function () {
        this.data.accountInfo = JSON.parse(android.getAccountInfo());
        this.refresh();
    };
    $scope.back = function () {
        rcwoApi.goback();
    };
    $scope.refresh = function () {
        this.data.pullToLoadMore.unfinished = {
            "show": false,
            "loading": false,
            "text": android.getString("loading")
        };
        this.data.pullToLoadMore.finished = {
            "show": false,
            "loading": false,
            "text": android.getString("loading")
        };
        this.data.more = {
            "finished": true,
            "unfinished": true
        };

        this.data.rcwostatu = {
            "needToSync": 0,
            "needToDeal": 0
        };
        if (this.isNetworkAvailable()) {
            android.setRefresh();
            this.data.warnData.showWarn = false;
            this.data.refreshStatus.finishedList = false;
            this.data.refreshStatus.unfinishedList = false;
            this.data.myListConfig.unfinished.page = 1;
            this.data.myListConfig.finished.page = 1;
            this.getUnfinishedList(true);
            this.getFinishedList(true);
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
            var rcwolist = $scope.data.rcwolist.unfinished;
            rcwolist.list = JSON.parse(rcwoApi.getRcwos($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum, 0, $scope.data.myListConfig.unfinished.pagesize));
            rcwolist.total = rcwolist.list.length;
            $scope.checkSchedule();
            android.refreshComplete();
        }
    };
    $scope.isNetworkAvailable = function () {
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            return true;
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
            android.refreshComplete();
            return false;
        }
    };
    $scope.getUnfinishedList = function (isrefresh) {
        $http({
            url: $scope.data.reqUrl,
            method: "POST",
            data: JSON.stringify({
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "type": "1",
                "page": $scope.data.myListConfig.unfinished.page.toString(),
                "pagesize": $scope.data.myListConfig.unfinished.pagesize.toString()
            }),
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                $scope.data.myListConfig.unfinished.page++;
                var more = Boolean($scope.data.myListConfig.unfinished.pagesize == res.total);
                if (more) {
                    $scope.data.pullToLoadMore.unfinished = {
                        "show": false,
                        "loading": false,
                        "text": android.getString("loading")
                    };
                } else {
                    $scope.data.pullToLoadMore.unfinished = {
                        "show": true,
                        "loading": false,
                        "text": android.getString("no_more")
                    };
                    $scope.data.more.unfinished = false;
                }
                if (isrefresh) {
                    $scope.data.rcwolist.unfinished.list = res.content;
                    $scope.data.refreshStatus.unfinishedList = true;
                    $scope.checkRefreshStatus();
                } else $scope.data.rcwolist.unfinished.list = $scope.data.rcwolist.unfinished.list.concat(res.content);
                $scope.data.rcwolist.unfinished.total = $scope.data.rcwolist.unfinished.list.length;
            } else {
                android.alert(res.message);
            }
            $scope.checkRefreshStatus();
        }).error(function () {
            android.showToast($scope.data.warning_and_error.rcwolist_error);
            $scope.data.refreshStatus.unfinishedList = true;
            $scope.checkRefreshStatus();
        });
    };
    $scope.getFinishedList = function (isrefresh) {
        $http({
            url: $scope.data.reqUrl,
            method: "POST",
            data: JSON.stringify({
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "type": "2",
                "isme": $scope.data.myListConfig.finished.isme,
                "page": $scope.data.myListConfig.finished.page.toString(),
                "pagesize": $scope.data.myListConfig.finished.pagesize.toString()
            }),
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                $scope.data.myListConfig.finished.page++;
                var more = Boolean($scope.data.myListConfig.finished.pagesize == res.total);
                if (more) {
                    $scope.data.pullToLoadMore.finished = {
                        "show": false,
                        "loading": false,
                        "text": android.getString("loading")
                    };
                } else {
                    $scope.data.pullToLoadMore.finished = {
                        "show": true,
                        "loading": false,
                        "text": android.getString("no_more")
                    };
                    $scope.data.more.finished = false;
                }
                if (isrefresh) {
                    $scope.data.rcwolist.finished.list = res.content;
                    $scope.data.refreshStatus.finishedList = true;
                    $scope.checkRefreshStatus();
                } else $scope.data.rcwolist.finished.list = $scope.data.rcwolist.finished.list.concat(res.content);
                $scope.data.rcwolist.finished.total = $scope.data.rcwolist.finished.list.length;
            } else {
                android.alert(res.message);
            }
        }).error(function () {
            $scope.data.pullToLoadMore.finished = {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            };
            $scope.data.more.finished = true;
            android.showToast($scope.data.warning_and_error.rcwohistory_error);
            $scope.data.refreshStatus.finishedList = true;
            $scope.checkRefreshStatus();
        });
    };
    $scope.unfinishedListLoadMore = function () {
        if (this.isNetworkAvailable()) {
            this.data.pullToLoadMore.unfinished.show = true;
            this.getUnfinishedList();
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
        }
    };
    $scope.finishedListLoadMore = function () {
        if (this.isNetworkAvailable()) {
            this.data.pullToLoadMore.finished.show = true;
            this.getFinishedList();
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
        }
    };
    $scope.refreshHistory = function () {
        if (this.isNetworkAvailable()) {
            android.setRefresh();
            this.data.warnData.showWarn = false;
            this.data.refreshStatus.finishedList = false;
            this.data.myListConfig.finished.page = 1;
            this.getFinishedList(true);
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
            android.refreshComplete();
        }
    };
    $scope.checkRefreshStatus = function () {
        var refreshStatus = this.data.refreshStatus;
        if (refreshStatus.finishedList && refreshStatus.unfinishedList) {
            android.refreshComplete();
            // android.showToast(android.getString("refreshComplete"));
        }
    };
    $scope.refreshUnfinished = function () {
        if (this.isNetworkAvailable()) {
            android.setRefresh();
            this.data.pullToLoadMore.unfinished = {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            };
            this.data.myListConfig.unfinished.page = 1;
            this.getUnfinishedList(true);
        }
    };
    $scope.historyDetail = function (wonum) {
        android.openActWithData("rcwo.Rcwohistory", wonum);
    };
    
    $scope.scan = function () {
        rctaskApi.scan();
    };
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    });
}

function getScanResult(result) {
    angularApply(function () {
        scope.data.searchbar.searchText = result;
    });
}