$(document).ready(function () {
    FastClick.attach(document.body);
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
    tab.on('beforeScrollStart', function (fromIndex, toIndex) {
        flag = toIndex;
    });
});

var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $focus, $timeout, $http) {
    $scope.data = {
        "pageText": "",
        "header": {
            "title": android.getString("title_rcwodetail"),
            "backtext": android.getString("back")
        },
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "pageData": null,
        "locList": null,
        "search": {
            "finished": "",
            "unfinished": ""
        },

        "searchbar": {
            "unfinished": {
                "focus": false,
                "searchText": "",
                "placeholder": "",
                "button": "",
                "characteristic": 0
            },
            "finished": {
                "focus": false,
                "searchText": "",
                "placeholder": "",
                "button": "",
                "characteristic": 1
            },
            "characteristic": ""
        },
        "workflow": {
            "show": false,
            "remark": ""
        },
        "signature": {
            "show": false,
            "name": ""
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "reasonnocomp": {
            "reason": "",
            "show": false
        },
        "prompt": {
            "uselabel": android.getString("is_uselabel"),
            "com_taskloc_order": android.getString("com_taskloc_order"),
            "loc_have_no_bleid": android.getString("loc_have_no_bleid"),
            "select_forward_target": android.getString("select_forward_target"),
            "check_first_loc": android.getString("check_first_loc")
        },
        "reqUrl": {
            "accountList": android.getReqUrl("accountlist"),
            "forwardworkflow": android.getReqUrl("forwardworkflow")
        },
        "showAccountList": false,
        "accountList": [],
        "assignee": "",
        "warnning_and_error": {
            "network_unavailable": android.getString("network_unavailable"),
            "accountlist_error": android.getString("accountlist_error"),
            "forward_error": android.getString("forward_error")
        },
        "sameLocationList": []
    }
    $scope.scan = function (characteristic) {
        rcwodetailApi.scan();
    }
    $scope.init = function () {
        this.data.pageText = JSON.parse(android.getJsonFromFile("rcwoDetail_pageText"));
        this.data.pageText.confirm = android.getString("confirm");
        this.data.pageText.cancel = android.getString("cancel");
        this.data.pageData = JSON.parse(rcwodetailApi.getPageData());
        console.log(rcwodetailApi.getPageData());
        var searchPlaceholder = this.data.pageText.search_placeholder,
            searchButton = this.data.pageText.search_button;
        this.data.searchbar.unfinished.placeholder = searchPlaceholder;
        this.data.searchbar.unfinished.button = searchButton;
        this.data.searchbar.finished.placeholder = searchPlaceholder;
        this.data.searchbar.finished.button = searchButton;
        this.data.signature.name = this.data.pageData.actexecutor || rcwodetailApi.getDefaultName();
        if (this.data.pageData.type == '1') {
            this.data.header.title = android.getString("title_rcwodetail");
            this.data.workflow.remark = this.data.pageData.reasoncancel;

        } else if (this.data.pageData.type == '2') {
            this.data.header.title = android.getString("title_rcwodetailreview");
            this.data.workflow.remark = this.data.pageData.reasonreturn;
        }
        this.getData();
    }
    $scope.getData = function () {
        this.data.locList = JSON.parse(rcwodetailApi.getRcwoloc());
        if (this.data.locList.unfinishedList.length) {
            rcwodetailApi.completedFirstLoc(this.data.locList.unfinishedList[0].sortid != "1")
        }
    }
    $scope.clickLoc = function (item, ongoing) {
        if (item.sortid != "1" && !this.checkCalsigntime()) {
            return;
        }
        if (rcwodetailApi.checkneedroute() == "1" && rcwodetailApi.checkcom(item.sortid) == "false") {
            android.showToast(this.data.prompt.com_taskloc_order);
        } else {
            if (item.uselabel) {
                switch (item.labeltype) {
                    case "Bluetooth":
                        if (item.bluetoothid) {
                            android.showToast(this.data.prompt.uselabel);
                            this.bluetooth(item.bluetoothid, item.location, item.sortid, item);
                        } else {
                            // this.openLoc(item, ongoing)
                            android.alert(this.data.prompt.loc_have_no_bleid);
                        }
                        break;
                    case "NFC":
                        android.showToast(this.data.prompt.uselabel);
                        break;
                    case "QRCODE":
                        android.showToast(this.data.prompt.uselabel);
                        this.openqrcode(item.location, item.sortid, item);
                        break;
                }
            } else {
                this.openLoc(item, ongoing);
            }
        }
    }
    $scope.openLoc = function (item, ongoing) { //打开巡更点
        rcwodetailApi.openLoc(JSON.stringify({
            "item": item,
            "ongoing": ongoing,
            "type": this.data.pageData.type
        }));
    }
    $scope.clearUnfinishedSearchText = function () {
        this.data.search.unfinished = "";
    }
    $scope.clearFinishedSearchText = function () {
        this.data.search.finished = ""
    }
    $scope.back = function () {
        rcwodetailApi.goback();
    }
    $scope.isNetworkAvailable = function () {
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            return true;
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warnning_and_error.network_unavailable;
            android.refreshComplete();
            return false;
        }
    }
    $scope.stopPropagation = function (e) {
        e.stopPropagation();
    }
    $scope.addRemark = function () {
        this.data.workflow.show = true;
        $focus("remark");
    }
    $scope.cancel = function () {
        this.data.workflow.show = false;
        this.data.workflow.remark = "";
    }
    $scope.confirmUpload = function (type, actionid) {
        if (type == "remark") {
            if (this.data.workflow.remark.replace(/\s/g, "") && this.data.workflow.remark.length <= 50) {
                this.data.reasonnocomp.reason = "";
                this.data.signature.name = "";
                this.data.workflow.show = false;
                this.commit(actionid);
            } else {
                android.alert(android.getString("input_remark"));
                return;
            }
            this.data.workflow.show = false;
        } else if (type == "signature") {
            // if (!/[^\u2E80-\u9FFFA-Za-z ·]/g.test(this.data.signature.name) && this.data.signature.name.replace(/\s/g, "") && this.data.signature.name.length <= 30) {
            if (!/[^\u2E80-\u9FFFA-Za-z ·]/g.test(this.data.signature.name) && this.data.signature.name.replace(/\s/g, "")) {
                this.data.workflow.remark = "";
                this.data.signature.show = false;
                this.commit(actionid);
            } else {
                android.alert(android.getString("input_signature"));
                return;
            }
        }
    }
    $scope.complete = function () {
        if (this.data.pageData.type == "1") {
            // android.alert(android.getString("rcwoloc_unfinished"));
            if (!this.checkCalsigntime()) return;
            if (this.data.locList.unfinishedList.length) {
                // 填写未全部完成的原因
                this.data.reasonnocomp.show = true;
                $focus("reasonnocomp");
            } else {
                this.data.reasonnocomp.reason = "";
                this.data.signature.show = true;
                $focus("signature");
            }
        } else if (this.data.pageData.type == "2") {
            this.commit(this.data.pageData.actionList[0])
        }
    }
    $scope.checkCalsigntime = function () {
        if (rcwodetailApi.getCalsigntime() && this.data.locList.unfinishedList.length && this.data.locList.unfinishedList[0].sortid == "1") {
            android.showToast(this.data.prompt.check_first_loc);
            return false;
        }
        return true;
    }
    $scope.signcancel = function () {
        this.data.signature.show = false;
        this.data.signature.name = this.data.pageData.actexecutor;
    }
    $scope.commit = function (actionid) {
        var uploadActionid = actionid.toString();
        rcwodetailApi.completeRcwo(
            this.data.pageData.wonum,
            this.data.pageData.type,
            uploadActionid,
            this.data.workflow.remark,
            this.data.signature.name,
            this.data.reasonnocomp.reason,
            this.data.pageData.index,
            this.data.accountInfo.hrid,
            this.data.accountInfo.penum
        );
    }
    $scope.openqrcode = function (location, sortid, item) {
        rcwodetailApi.openqrcode(location, sortid, JSON.stringify({
            "item": item,
            "ongoing": true,
            "type": this.data.pageData.type
        }))
    }
    $scope.useqrcode = function (e, location, sortid, item) {
        e.stopPropagation();
        this.openqrcode(location, sortid, item);
    }
    $scope.bluetooth = function (bluetoothid, location, sortid, item) {
        rcwodetailApi.openbluetooth(bluetoothid, location, sortid, JSON.stringify({
            "item": item,
            "ongoing": true,
            "type": this.data.pageData.type
        }));
    }
    $scope.usebluetooth = function (e, bluetoothid, item) {
        e.stopPropagation();
        if (bluetoothid)
            this.bluetooth(bluetoothid, item.location, item.sortid, item);
        else
            android.alert(this.data.prompt.loc_have_no_bleid);
        // this.openLoc(item, true);
    }
    $scope.nfc = function (e, location, item) {
        e.stopPropagation();
        rcwodetailApi.opennfc(location, JSON.stringify({
            "item": item,
            "ongoing": true,
            "type": this.data.pageData.type
        }))
    }
    var finishedTimer, unfinishedTimer = null;
    $scope.setTimer = function (timer, callback) {
        if (timer) {
            $timeout.cancel(timer);
        } else {
            timer = $timeout(callback, 500);
        }
    }
    $scope.completecancel = function () {
        this.data.reasonnocomp.show = false;
        this.data.reasonnocomp.reason = "";
    }
    $scope.goSignature = function () {
        if (this.data.reasonnocomp.reason.replace(/\s/g, "") && this.data.reasonnocomp.reason.length <= 50) {
            this.data.reasonnocomp.show = false;
            this.data.signature.show = true;
            $focus("signature");
        } else {
            android.alert(android.getString("input_reasonnocomp"));
            return;
        }
    }
    $scope.$watch("data.searchbar.finished.searchText", function (newVal) {
        if (newVal) {
            $scope.setTimer(finishedTimer, function () {
                $scope.data.locList.finishedList.forEach(function (item) {
                    if (item.location == newVal)
                        $scope.openLoc(item, true);
                })
            })
        }
    });
    $scope.$watch("data.searchbar.unfinished.searchText", function (newVal) {
        if (newVal) {
            // $scope.setTimer(unfinishedTimer, function () {
            //     $scope.data.locList.unfinishedList.forEach(function (item) {
            //         if (item.location == newVal) {
            //             if (item.labeltype == 'QRCODE') { // 标签类型为二维码
            //                 rcwodetailApi.filterResult(JSON.stringify({
            //                     "item": item,
            //                     "ongoing": true,
            //                     "type": $scope.data.pageData.type
            //                 }), newVal);
            //             } else if (!item.uselabel) { // 地点不是必须扫二维码才开启

            //                 if (!this.checkCalsigntime() && item.sortid != "1") {
            //                     return;
            //                 }
            //                 if (rcwodetailApi.checkneedroute() == "1" && rcwodetailApi.checkcom(item.sortid) == "false") {
            //                     android.showToast(this.data.prompt.com_taskloc_order);
            //                     return;
            //                 }
            //                 $scope.openLoc(item, true);
            //             }
            //         }
            //     })
            // })
            var canopen = false;
            var match = false;
            $scope.setTimer(unfinishedTimer, function () {
                for (var i = 0, len = $scope.data.locList.unfinishedList.length; i < len; i++) {
                    console.log($scope.data.locList.unfinishedList[i].location);
                    if ($scope.data.locList.unfinishedList[i].location == newVal) {
                        var item = $scope.data.locList.unfinishedList[i];
                        match = true;
                        if (item.labeltype == "QRCODE" || !item.uselabel) {
                            canopen = true;
                            break;
                        }
                    }
                }
                if (canopen) {
                    rcwodetailApi.filterResult(newVal);
                } else if (match) {
                    this.sameLocationHandler(newVal, true);
                }
            });
        }
    });
    $scope.setShowAccountList = function (show) {
        this.data.showAccountList = show;
        rcwodetailApi.setShowAccountList(show);
        if (!show) this.data.assignee = "";
    }
    $scope.getShowAccountList = function () {
        return this.data.showAccountList;
    }
    $scope.showAccountList = function () {
        this.setShowAccountList(true);
        this.getAccountList();
    }
    $scope.getAccountList = function () {
        if (this.data.accountList.length) return;
        this.data.accountList = JSON.parse(rcwodetailApi.getForwardAccountList(this.data.accountInfo.hrid, this.data.accountInfo.penum));
    }
    $scope.forward = function () {
        if (!this.data.assignee) {
            android.alert(this.data.prompt.select_forward_target);
            return;
        }
        if (!this.isNetworkAvailable()) {
            return
        }
        android.setRefresh();
        $http({
            url: $scope.data.reqUrl.forwardworkflow,
            method: "POST",
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "assignee": $scope.data.assignee,
                "ownerid": $scope.data.pageData.ownerid,
                "ownertable": "RCWO"
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                // $scope.data.accountList = res.content;
                rcwodetailApi.finishForward();
            } else {
                android.alert(res.message);
            }
            android.refreshComplete();
        }).error(function () {
            android.alert($scope.data.warnning_and_error.forward_error);
            android.refreshComplete();
        })
    }
    $scope.clickSameLoc = function (item) {
        if (item.sortid != "1" && !this.checkCalsigntime()) {
            return;
        }
        if (rcwodetailApi.checkneedroute() == "1" && rcwodetailApi.checkcom(item.sortid) == "false") {
            android.showToast(this.data.prompt.com_taskloc_order);
            return;
        }
        if(this.data.pageData.autoscan){
           rcwodetailApi.autoscanture(item.location,item.sortid);
        }else{
        this.openLoc(item, true);
        }
    }
    $scope.sameLocationHandler = function (location, fromSearchBar) {
        this.data.sameLocationList = this.data.locList.unfinishedList.filter(function (loc) {
            return loc.location == location;
        });
        if (this.data.sameLocationList.length) {
            if (!fromSearchBar && (rcwodetailApi.checkneedroute == "1" || this.data.sameLocationList.length == 1)) {
                this.openLoc(this.data.sameLocationList[0], true);
            } else {
                this.setShowSameLocations(true);
            }
        }
    }
    $scope.setShowSameLocations = function (show) {
        this.data.showSameLocations = show;
        rcwodetailApi.setShowSameLocations(show);
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        if (scope.data.showAccountList) {
            scope.data.assignee = "";
            scope.getAccountList();
        }
        scope.getData();
        android.refreshComplete();
    })
}

function getScanResult(result) {
    angularApply(function () {
        if (scope.data.searchbar.characteristic)
            scope.data.searchbar.finished.searchText = result;
        else
            scope.data.searchbar.unfinished.searchText = result;
    })
}

function refresh(sortid, ongoing, description, abnormal) {
    angularApply(function () {
        if (sortid) {
            var list = null;
            if (ongoing) {
                if (sortid == "1") {
                    rcwodetailApi.completedFirstLoc(true);
                }
                list = scope.data.locList.unfinishedList;
            } else {
                list = scope.data.locList.finishedList;
            }
            for (var i = 0, len = list.length; i < len; i++) {
                if (sortid == list[i].sortid) {
                    list[i].description = description;
                    list[i].abnormal = abnormal;
                    if (ongoing)
                        scope.data.locList.finishedList.push(list.splice(i, 1)[0]);
                    break;
                }
            }
            scope.data.searchbar.unfinished.focus = false;
            scope.data.searchbar.unfinished.searchText = "";
            scope.setShowSameLocations(false);
        }
    })
}

function setShowAccountList(isShow) {
    angularApply(function () {
        scope.setShowAccountList(isShow);
    })
}

function sameLocationHandler(location, fromSearchBar) {
    angularApply(function () {
        scope.sameLocationHandler(location, fromSearchBar);
    })
}

function setShowSameLocations(show) {
    angularApply(function () {
        scope.setShowSameLocations(show);
    })
}