var app = angular.module('myApp', ["component"]);
app.controller('myCtrl', function ($scope) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("rcwoItem_pageText")),
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "header": {
            "title": android.getString("title_rcwoitem"),
            "backtext": android.getString("back")
        },
        "pageData": null,
        "imgList": [],
        "ongoing": false,
        "finished": true,
        "arr": [],
        "save": {
            "detial": [],
            "loc": {}
        },
        "rcwoItemList": null,
        "multiSelectBox": {
            "show": false,
            "currVal": "",
            "arr": null,
            "target": null
        },
        "dateTest": "",
        "currDateTarget": "",
        "warning_and_error": {
            "remark_error": android.getString("remark_error"),
            "need_photo": android.getString("need_photo")
        },
        "preview": {
            "imgList": [],
            "show": false,
            "curr": ""
        },
        "imgListChanged": false,
        "needphoto": false
    };
    $scope.init = function () {
        var pageData = JSON.parse(rcwoItemApi.getPageData());
        this.data.pageData = pageData.item;
        this.data.ongoing = pageData.ongoing;
        this.data.type = pageData.type;
        this.setArrivalTime();
        this.data.needphoto = rcwoItemApi.getNeedPhoto(pageData.item.wonum, this.data.accountInfo.hrid, this.data.accountInfo.penum) || pageData.item.needphoto;
        this.data.rcwoItemList = JSON.parse(rcwoItemApi.getRcwoDetail(pageData.item.wonum, pageData.item.location, pageData.item.sortid, this.data.accountInfo.hrid, this.data.accountInfo.penum));
        console.log(this.data.rcwoItemList);
        if (!this.data.pageData.ongoing || this.data.type == '2') {
            var temImgList = JSON.parse(rcwoItemApi.getImgList(pageData.item.wonum, pageData.item.location, pageData.item.sortid, this.data.accountInfo.hrid, this.data.accountInfo.penum));
            if (temImgList[0]) {
                this.data.imgList.push(temImgList[0]);
                if (temImgList[1]) {
                    this.data.imgList.push(temImgList[1]);
                    if (temImgList[2]) this.data.imgList.push(temImgList[2]);
                }
            }
        }
    };
    $scope.setArrivalTime = function () {
        rcwoItemApi.setArrivalTime(this.data.pageData.wonum, this.data.pageData.location, this.data.pageData.sortid, this.data.accountInfo.hrid, this.data.accountInfo.penum, (new Date()).toLocaleString("zh-CN", {
            hour12: false
        }).replace(/\//g, "-").replace(/-(?!\d\d)/g, "-0"))
    }
    $scope.addPic = function () {
        rcwoItemApi.addPic();
    };
    $scope.deleteImg = function (index) {
        this.data.imgList.splice(index, 1);
    };
    $scope.back = function () {
        rcwoItemApi.goback();
    };

    $scope.preview = function (curr) {
        if (this.data.imgListChanged) {
            this.data.preview.imgList = this.data.imgList.map(function (img) {
                return img;
            });
            this.data.imgListChanged = false;
        }
        this.data.preview.show = true;
        this.data.preview.curr = curr;
        rcwoItemApi.setishow();
    };
    $scope.createEventReport = function () {
        rcwoItemApi.createEventReport(JSON.stringify({
            "hrid": this.data.accountInfo.hrid,
            "penum": this.data.accountInfo.penum,
            "wonum": this.data.pageData.wonum
        }));
    };
    $scope.multiSelect = function (valueList, currVal, target, inputtype) {
        if (inputtype != "MULTISELECT") return;
        this.data.multiSelectBox.arr = valueList;
        this.data.multiSelectBox.currVal = currVal;
        this.data.multiSelectBox.show = true;
        this.data.multiSelectBox.target = target - 1;
    };
    $scope.save = function () {
        var detail = this.checkData();
        if (detail) {
            var save = {
                "detail": detail,
                "loc": {
                    "wonum": this.data.pageData.wonum,
                    "location": this.data.pageData.location,
                    "pic1url": this.data.imgList[0] || "",
                    "pic2url": this.data.imgList[1] || "",
                    "pic3url": this.data.imgList[2] || "",
                    "sortid": this.data.pageData.sortid,
                    "description": this.data.pageData.description,
                    "patroldate": new Date().toLocaleString("zh-CN", {
                        hour12: false
                    }).replace(/\//g, "-").replace(/-(?!\d\d)/g, "-0"),
                    "abnormal": this.data.pageData.abnormal || "0",
                    "ongoing": this.data.ongoing
                }
            };
            // if (this.data.ongoing) {
            //     var nowDate = new Date();
            //     save.patroldate = nowDate.toLocaleString("zh-CN", {
            //         hour12: false
            //     }).replace(/\//g, "-");
            // }
            if (this.data.imgList.length) save.loc.pic = true;
            else save.loc.pic = false;
            rcwoItemApi.save(JSON.stringify(save), this.data.accountInfo.hrid, this.data.accountInfo.penum);
        }
    };
    $scope.checkData = function () {
        var requiredList = this.data.rcwoItemList.filter(function (item) {
            return item.needfeedback && !item.feedback;
        });
        if (requiredList.length) {
            android.alert(android.getCustomString("input_rcwodetail", requiredList.reduce(function (accumulator, curr) {
                return accumulator + (curr.description + " ");
            }, " ")));
            return;
        }
        var numericalList = this.data.rcwoItemList.filter(function (item) {
            return item.restriction == 'NUMERICAL';
        });
        var numericalReg = /^\d+(\.\d+)?$/g
        var numerical = numericalList.filter(function (item) {
            return !numericalReg.test(item.feedback.replace(/\s/g, ""));
        });
        if (numerical.length) {
            android.alert(android.getCustomString("numerical_error", numerical.reduce(function (accumulator, curr) {
                return accumulator + (curr.description + " ");
            }, " ")));
            return;
        }
        if (this.data.pageData.description.length > 100) {
            android.alert(this.data.warning_and_error.remark_error);
            return;
        }
        if (this.data.needphoto && this.data.imgList.length == 0) {
            android.alert(this.data.warning_and_error.need_photo);
            return;
        }
        return this.data.rcwoItemList;
    };
    $scope.createReport = function () {
        rcwoItemApi.createEventReport(JSON.stringify({
            "hrid": this.data.accountInfo.hrid,
            "penum": this.data.accountInfo.penum,
            "wonum": this.data.pageData.wonum,
            "locdesc": this.data.pageData.locdesc,
            "description": this.data.pageData.description
        }));
    };
    $scope.$watch("data.multiSelectBox.currVal", function (newVal) {
        if ($scope.data.multiSelectBox.target != null) $scope.data.rcwoItemList[$scope.data.multiSelectBox.target].feedback = newVal;
    });
    $scope.datePicker = function (index) {
        this.data.currDateTarget = index;
        rcwoItemApi.showDatePicker();
    };
    $scope.$watch("data.imgList.length", function () {
        $scope.data.imgListChanged = true;
    })
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function getImg(base64) {
    angularApply(function () {
        scope.data.imgList.push(base64);
    });
}

function inputDate(dateString) {
    angularApply(function () {
        scope.data.rcwoItemList[scope.data.currDateTarget].feedback = dateString;
    });
}

function closeimage() {
    angularApply(function () {
        scope.data.preview.show = false;
    })
}