$(document).ready(function () {
    FastClick.attach(document.body); //防止点透
    //tab
    var tab = new fz.Scroll('.ui-tab', {
        role: 'tab',
        autoplay: false
    });
});
var app = angular.module("myApp", ["component"]);
app.controller("myCtrl", function ($scope, $http) {
    $scope.data = {
        "pageText": null,
        "header": {
            "title": android.getString("title_rcwohistorydetail"),
            "backtext": android.getString("back")
        },
        "reqUrl": {
            "rcwodetail": android.getReqUrl("rcwodetail"),
            "relER": android.getReqUrl("eventlist")
        },
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "wonum": null,
        "relErList": null,
        "rcwo": null,
        "refreshStatu": {
            "rcwodetail": false,
            "erlist": false
        },
        "showdetail": false,
        "warning_and_error": {
            "network_unavailable": android.getString("network_unavailable")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": null
        },
        // "abnormal": false,
        "multiSelectBox": {
            "show": false,
            "currVal": 0,
            "arr": null,
            "target": null
        },
        "preview": {
            imgList: [],
            show: false,
            curr: 0,
            currLoc: null
        }
    };
    $scope.init = function () {
        this.data.pageText = JSON.parse(android.getJsonFromFile("rcwohistory_pageText"));
        this.data.wonum = rcwohistoryApi.getWonum();
        this.refresh();
        this.data.multiSelectBox.arr = [{
            "name": this.data.pageText.all_inspat,
            "value": 0
        }, {
            "name": this.data.pageText.only_abnormal,
            "value": 1
        }, {
            "name": this.data.pageText.only_patrolled,
            "value": 2
        }, {
            "name": this.data.pageText.only_unpat,
            "value": 3
        }];
    };
    $scope.refresh = function () {
        if (android.isNetworkAvailable()) {
            android.setRefresh();
            this.getRcwoDetail();
            this.getER();
        } else {
            android.refreshComplete();
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;

        }
    };
    $scope.getRcwoDetail = function () {
        this.data.refreshStatu.rcwodetail = false;
        $http({
            url: $scope.data.reqUrl.rcwodetail,
            data: {
                hrid: $scope.data.accountInfo.hrid,
                penum: $scope.data.accountInfo.penum,
                wonum: $scope.data.wonum
            },
            method: "POST",
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                $scope.data.rcwo = res.content;
            } else {
                android.showToast(res.message);
            }
            $scope.data.refreshStatu.rcwodetail = true;
            $scope.checkRefreshStatu();
        }).error(function () {
            $scope.data.refreshStatu.rcwodetail = true;
            $scope.checkRefreshStatu();
        })
    }
    $scope.getER = function () {
        if (android.isNetworkAvailable()) {
            $http({
                url: $scope.data.reqUrl.relER,
                data: JSON.stringify({
                    "hrid": $scope.data.accountInfo.hrid,
                    "penum": $scope.data.accountInfo.penum,
                    "wonum": $scope.data.wonum
                }),
                method: "post",
                responseType: "json",
                timeout: 1000
            }).success(function (res) {
                if (res.success) {
                    $scope.data.relErList = res.content;
                } else {
                    android.showToast(res.message);
                }
                $scope.data.refreshStatu.erlist = true;
                $scope.checkRefreshStatu();
            }).error(function () {
                $scope.data.refreshStatu.erlist = true;
                $scope.checkRefreshStatu();
            });
        } else {
            this.data.warnData.showWarn = true;
        }
    };
    $scope.checkRefreshStatu = function () {
        if (this.data.refreshStatu.rcwodetail && this.data.refreshStatu.erlist)
            android.refreshComplete();
    }
    $scope.back = function () {
        rcwohistoryApi.goback();
    };
    $scope.showdetail = function () {
        this.data.showdetail = !this.data.showdetail;
    }
    $scope.multiSelect = function () {
        this.data.multiSelectBox.show = true;
        rcwohistoryApi.setishow();
    }
    $scope.preview = function (loc, index) {
        if (this.data.preview.currLoc != loc.location) {
            this.data.preview.currLoc = loc.location;
            this.data.preview.imgList = [];
            this.data.preview.imgList.push(loc.picurl1);
            if (loc.picurl2) {
                this.data.preview.imgList.push(loc.picurl2);
                if (loc.picurl3)
                    this.data.preview.imgList.push(loc.picurl3);
            }
        }
        this.data.preview.curr = index;
        this.data.preview.show = true;
        rcwohistoryApi.setishow();
    }
});

// app.filter('abnormalFilter', function() { //仅显示异常项过滤器
//     return function(rcwolocList, abnormal) {
//         return abnormal? rcwolocList.filter(function(rcwoloc){
//             return rcwoloc.abnormal
//         }) : rcwolocList
//     }
// });
app.filter("rcwolocFilter", function () {
    return function (rcwolocList, condition) {
        switch (condition) {
            case 0:
                return rcwolocList;
            case 1:
                return rcwolocList.filter(function (rcwoloc) {
                    return rcwoloc.abnormal
                })
            case 2:
                return rcwolocList.filter(function (rcwoloc) {
                    return rcwoloc.patroldate
                })
            case 3:
                return rcwolocList.filter(function (rcwoloc) {
                    return !rcwoloc.patroldate
                })
            default:
                return;
        }
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    });
}


function closeMask() {
    angularApply(function () {
        scope.data.preview.show = false;
        scope.data.multiSelect.show = false;
    })
}