var app = angular.module('myApp', ["component", "pr.longpress"]);
app.controller('myCtrl', function ($scope, $http) {
    $scope.data = {
        "pageText": null,
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "header": {
            "title": android.getString("title_loginMana"),
            "backText": android.getString("back")
        },
        "accountList": null,
        "showActionSheet": "",
        "target": JSON.parse(android.getAccountInfo())
    }
    $scope.init = function () {
        this.data.pageText = JSON.parse(android.getJsonFromFile("relAccount_pageText"));
        this.data.accountList = JSON.parse(relAccountApi.getRelAccountList());
    }
    $scope.back = function () {
        relAccountApi.goback();
    }
    $scope.addNewAccount = function () {
        relAccountApi.addNewAccount();
    }
    $scope.switchAccount = function (item) {
        relAccountApi.switchAccount(JSON.stringify(item));
    }
    $scope.logout = function () {
        relAccountApi.deleteRelAccount(JSON.stringify(this.data.accountInfo));
    }
    $scope.onLongPress = function (item, index) {
        this.data.showActionSheet = "show";
        this.data.target = {
            hrid: item.hrid,
            penum: item.penum
        };
        this.data.targetIndex = index;
    }
    $scope.deleteRelAccount = function () {
        this.hide();
        relAccountApi.deleteRelAccount(JSON.stringify(this.data.target));
        this.data.accountList.splice(this.data.targetIndex, 1);
    }
    $scope.hide = function () {
        this.data.showActionSheet = "";
    }
    $scope.checkCanSync = function(target, currentAccount) {
        if(android.checkCanSync(target.hrid, target.penum)) {
            var func = "";
            if(currentAccount) {
                func = "logout()"
            } else {
                func = "deleteRelAccount()"
            }
            android.dialog("", android.getString("logout_local_data"), func, "")
        } else {
            this.deleteRelAccount();
            // relAccountApi.deleteRelAccount(JSON.stringify(target))
        }
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function deleteRelAccount () {
    angularApply(function() {
        scope.deleteRelAccount();
    })
}

function logout() {
    angularApply(function () {
        scope.logout();
    });
}