var app = angular.module('myApp', ["component"]);
app.controller('myCtrl', function ($scope, $http) {
    $scope.data = {
        "pageText": null,
        "verName": null,
        "serialnum": null,
        "reqUrl": {
            "checkVer": android.getReqUrl("appversion"),
            "changeLang": android.getReqUrl("changelang")
        },
        "header": {
            "title": android.getString("title_setting"),
            "backText": android.getString("back")
        },
        "nothing": android.getString("can_not_use"),
        "accountInfo": JSON.parse(android.getAccountInfo()),
        "warning_and_error": {
            "get_version_infor_error": android.getString("get_version_infor_error"),
            "network_unavailable": android.getString("network_unavailable")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "lang": {
            "list": null,
            "show": false,
            "currlang": ""
        }
    }
    $scope.init = function () {
        this.data.pageText = JSON.parse(android.getJsonFromFile("setting_pageText"));
        this.data.verName = settingApi.getVerName();
        this.data.serialnum = settingApi.getVerCode();
        this.data.lang.currlang = settingApi.getCurrLang();
    }
    $scope.nothing = function () {
        android.alert(this.data.nothing);
    }
    $scope.isNetworkAvailable = function () {
        if (!android.isNetworkAvailable()) {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = this.data.warning_and_error.network_unavailable;
            return false;
        } else {
            this.data.warnData.showWarn = false;
            return true;
        }
    }
    $scope.consult = function () {
        settingApi.setUrl(1);
    }
    $scope.introduction = function () {
        settingApi.setUrl(2);
    }
    $scope.checkUpdate = function () {
        if (this.isNetworkAvailable()) {
            $http({
                url: $scope.data.reqUrl.checkVer,
                method: "POST",
                data: {
                    "hrid": $scope.data.accountInfo.hrid,
                    "appname": "313FM",
                    "serialnum": $scope.data.serialnum
                },
                responseType: "json",
                timeout: 5000
            }).success(function (res) {
                if (res.success) {
                    settingApi.checkUpdate(res.content.url, res.content.version);
                } else {
                    android.alert(res.message)
                }
            }).error(function () {
                android.showToast($scope.data.warning_and_error.get_version_infor_error);
            })
        }
    }
    $scope.changeLang = function () {
        if (!this.data.lang.list) {
            this.data.lang.list = JSON.parse(settingApi.getLangList());
        }
        this.data.lang.show = true
    }
    $scope.haveRelAccount = function () {
        if (settingApi.haveRelAccount()) {
            android.dialog("", android.getString("logout_rel_account"), "logout()", "");
        } else settingApi.logout();
    }
    $scope.checkCanSync = function() {
        if(android.checkCanSync()) {
            android.dialog("", android.getString("logout_all_local_data"), "haveRelAccount()", "")
        } else {
            // settingApi.logout();
            this.haveRelAccount();
        }
    }
    $scope.logout = function () {
        settingApi.logout();
    }
    $scope.back = function () {
        settingApi.goback();
    }
    $scope.$watch("data.lang.currlang", function (newVal, oldVal) {
        if (newVal != oldVal) {
            $scope.changeDefaultLang(newVal);
        }
    });
    $scope.changeDefaultLang = function (lang) {
        if (this.isNetworkAvailable()) {
            $http({
                url: $scope.data.reqUrl.changeLang,
                data: {
                    "hrid": $scope.data.accountInfo.hrid,
                    "penum": $scope.data.accountInfo.penum,
                    "language": lang
                },
                "method": "POST",
                "responseType": "json",
                "timeout": 10000
            }).success(function (res) {
                if (!res.success)
                    android.showToast(android.getString("change_default_language_failed"));
                settingApi.changeLang(lang);
            }).error(function () {
                android.showToast(android.getString("change_default_language_failed"));
                settingApi.changeLang(lang);
            })
        }
    }
    $scope.changeAccount = function () {
        android.openAct("setting.RelAccount");
    }
})

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function logout() {
    angularApply(function () {
        scope.logout();
    });
}

function haveRelAccount() {
    angularApply(function() {
        scope.haveRelAccount();
    })
}