var app = angular.module('myApp', ['component', 'loadMore']);
app.controller("myCtrl", function ($scope, $http, $interval) {
    $scope.data = {
        "pageText": JSON.parse(android.getJsonFromFile("taskBox_pageText")),
        "accountInfo": null,
        "query": null,
        "reqUrl": {
            "unfinished": android.getReqUrl("rcwoassignment"),
            "sync": android.getReqUrl("rcwocomp"),
            "syncER": android.getReqUrl("addevent")
        },
        "warnData": {
            "showWarn": false,
            "warnMsg": ""
        },
        "warning_and_error": {
            "rcwolist_error": android.getString("rcwolist_error"),
            "no_rcwo_need_to_sync": android.getString("no_rcwo_need_to_sync"),
            "rcwo_is_to": android.getString("rcwo_is_to"),
            "do_u_need_to_sync_er": android.getString("do_u_need_to_sync_er")
        },
        "header": {
            "title": android.getString("title_taskbox"),
            "backtext": android.getString("back")
        },
        "tasklist": {
            "rcwolist": {
                "total": null,
                "list": []
            }
        },
        "rcwostatu": {
            "needToSync": 0,
            "needToDeal": 0
        },
        "refreshStatus": {
            "unfinishedList": true
        },
        "pullToLoadMore": {
            "unfinished": {
                "show": false,
                "loading": false,
                "text": android.getString("loading")
            }
        },
        "more": {
            "unfinished": true
        },
        "myListConfig": {
            "unfinished": {
                "page": 0,
                "pagesize": 10
            }
        },
        "uploadStatus": {
            "total": 0,
            "success": 0,
            "failed": 0,
            "successWonumList": []
        },
        "refreshTime": "",
        "eventReport": {
            "success": 0,
            "failed": 0,
            "needToSyncER": false,
            "ERTotal": 0,
            "ERList": null
        }
    };
    $scope.init = function () {
        this.data.accountInfo = JSON.parse(android.getAccountInfo());
        this.data.refreshTime = taskApi.getRefreshTime(this.data.accountInfo.hrid, this.data.accountInfo.penum);
        this.refresh();
    };
    $scope.openRcwo = function (rcwo, index) {
        taskApi.openActForResultWithData("rcwo.RcwoDetail", JSON.stringify({
            "hrid": $scope.data.accountInfo.hrid,
            "penum": $scope.data.accountInfo.penum,
            "wonum": rcwo.wonum,
            "description": rcwo.description,
            "remarks": rcwo.remarks,
            "scheddate": rcwo.scheddate,
            "schedule": rcwo.schedule,
            "actionList": rcwo.actionList,
            "index": index,
            "type": rcwo.type,
            "reasoncancel": rcwo.reasoncancel,
            "reasonreturn": rcwo.reasonreturn,
            "actexecutor": rcwo.actexecutor,
            "actcompdate": rcwo.actcompdate,
            "reasonnocomp": rcwo.reasonnocomp,
            "autoscan": rcwo.autoscan,
            "ownerid": rcwo.ownerid
        }));
    };
    $scope.back = function () {
        taskApi.goback();
    };
    $scope.refresh = function () {
        this.data.pullToLoadMore.unfinished = {
            "show": false,
            "loading": false,
            "text": android.getString("loading")
        };
        this.data.more = {
            "unfinished": true
        };

        this.data.rcwostatu = {
            "needToSync": 0,
            "needToDeal": 0
        };
        if (this.isNetworkAvailable()) {
            android.setRefresh();
            this.data.warnData.showWarn = false;
            this.data.refreshStatus.unfinishedList = false;
            this.data.myListConfig.unfinished.page = 0;
            this.getUnfinishedList(true);
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
            $scope.data.tasklist.rcwolist.list = JSON.parse(taskApi.getAllRcwos($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum));
            $scope.checkSchedule();
            android.refreshComplete();
        }
    };
    $scope.isNetworkAvailable = function () {
        if (android.isNetworkAvailable()) {
            this.data.warnData.showWarn = false;
            return true;
        } else {
            this.data.warnData.showWarn = true;
            this.data.warnData.warnMsg = android.getString("network_unavailable");
            android.refreshComplete();
            return false;
        }
    };
    $scope.getUnfinishedList = function () {
        $http({
            url: $scope.data.reqUrl.unfinished,
            method: "POST",
            data: {
                "hrid": $scope.data.accountInfo.hrid,
                "penum": $scope.data.accountInfo.penum,
                "tstamp": $scope.data.refreshTime
            },
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                var hrid = $scope.data.accountInfo.hrid,
                    penum = $scope.data.accountInfo.penum;
                // 删除已被系统删除的巡检单
                if (res.content.deletercwo) taskApi.removeRcwo(JSON.stringify(res.content.deletercwo), hrid, penum);
                //保存获取的数据到本地
                //存储最后请求的时间
                $scope.data.refreshTime = res.content.tstamp;
                taskApi.saveTstamp(hrid, penum, res.content.tstamp);
                if (res.content.rcwo.length) {
                    taskApi.saveNewRcwo(JSON.stringify(res.content.rcwo), hrid, penum);
                    if (res.content.rcwoloc && res.content.rcwoloc.length) taskApi.saveNewRcwolocs(JSON.stringify(res.content.rcwoloc), hrid, penum);
                    if (res.content.rcwolist && res.content.rcwolist.length) taskApi.saveNewRcwoDetail(JSON.stringify(res.content.rcwolist), hrid, penum);
                }
                // 从本地获取巡检单
                $scope.data.tasklist.rcwolist.list = JSON.parse(taskApi.getAllRcwos($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum));

                $scope.data.refreshStatus.unfinishedList = true;
                $scope.checkSchedule();
            } else {
                android.alert(res.message);
            }
            $scope.checkRefreshStatus();
        }).error(function () {
            android.showToast($scope.data.warning_and_error.rcwolist_error);
            $scope.data.refreshStatus.unfinishedList = true;
            $scope.checkRefreshStatus();
        });
    };
    $scope.unfinishedListLoadMore = function () {
        if (this.data.more.unfinished) {
            this.data.pullToLoadMore.unfinished.loading = true;
            this.data.pullToLoadMore.unfinished.text = android.getString("loading")
            //从本地加载数据
            var temData = JSON.parse(taskApi.getRcwos(this.data.accountInfo.hrid, this.data.accountInfo.penum, ++this.data.myListConfig.unfinished.page, this.data.myListConfig.unfinished.pagesize));
            if (temData.length < this.data.myListConfig.unfinished.pagesize) {
                this.data.more.unfinished = false;
                this.data.pullToLoadMore.unfinished.text = android.getString("no_more");
            } else {
                this.data.pullToLoadMore.unfinished.text = android.getString("load_more");
            }
            this.data.tasklist.rcwolist.list = this.data.tasklist.rcwolist.list.concat(temData);
            this.data.pullToLoadMore.unfinished.loading = false;
        }
    };
    $scope.checkRefreshStatus = function () {
        var refreshStatus = this.data.refreshStatus;
        if (refreshStatus.unfinishedList) {
            android.refreshComplete();
            android.showToast(android.getString("refreshComplete"));
        }
    };
    $scope.checkSchedule = function () {
        var json = JSON.parse(taskApi.getTaskTotal($scope.data.accountInfo.hrid, $scope.data.accountInfo.penum));
        if (json.Completed) {
            this.data.rcwostatu.needToSync = parseInt(json.Completed);
        } else {
            this.data.rcwostatu.needToSync = 0;
        }
        if (json.Notstarted) {
            json.Notstarted = parseInt(json.Notstarted)
        } else {
            json.Notstarted = 0
        }
        if (json.Ongoing) {
            json.Ongoing = parseInt(json.Ongoing)
        } else {
            json.Ongoing = 0;
        }
        this.data.rcwostatu.needToDeal = json.Notstarted + json.Ongoing;
        this.data.tasklist.rcwolist.total = this.data.rcwostatu.needToSync + this.data.rcwostatu.needToDeal
    };
    $scope.syncAll = function () {
        if (this.isNetworkAvailable()) {
            var syncList = this.data.tasklist.rcwolist.list.filter(function (item) {
                return item.schedule == 'Completed';
            });
            if (syncList.length) {
                taskApi.loadingDialog();
                taskApi.setTaskLoadingText();
                this.data.uploadStatus.total = syncList.length;
                this.data.uploadStatus.success = 0;
                this.data.uploadStatus.failed = 0;
                var times = syncList.length - 1;
                var count = 1;

                this.syncRcwo(syncList[0], true);
                if (times) { //一张单以上
                    $interval(function () { //第二张单开始没账单延时两秒钟上传
                        $scope.syncRcwo(syncList[count++], true);
                    }, 2000, times);
                }
                // for(var i = 0; i < syncList.length; i++) {
                //     this.syncRcwo(syncList[i], true);
                // }
            } else {
                android.showToast(this.data.warning_and_error.no_rcwo_need_to_sync);
            }
        }
    };
    $scope.confirmSync = function (e, item, index) {
        e.stopPropagation();
        if (this.isNetworkAvailable()) this.syncRcwo(item, false, index);
    };
    $scope.syncRcwo = function (item, syncAll, index) {
        if (!syncAll) {
            taskApi.loadingDialog();
            taskApi.setTaskLoadingText();
        }
        var rcwoloc = JSON.parse(taskApi.getLoc(item.wonum));
        var hrid = this.data.accountInfo.hrid,
            penum = this.data.accountInfo.penum;
        rcwoloc.forEach(function (element) {
            element.rcwolist = JSON.parse(taskApi.getDetail(item.wonum, element.location, element.sortid, hrid, penum));
        });
        var data = {
            "hrid": this.data.accountInfo.hrid,
            "penum": this.data.accountInfo.penum,
            "wonum": item.wonum,
            "actionid": item.actionid,
            "type": item.type,
            "reasonreturn": item.reasonreturn,
            "reasoncancel": item.reasoncancel,
            "actcompdate": item.actcompdate,
            "actexecutor": item.actexecutor,
            "reasonnocomp": item.reasonnocomp,
            "rcwoloc": rcwoloc
        };
        $http({
            url: $scope.data.reqUrl.sync,
            data: data,
            method: "POST",
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                if (syncAll) {
                    $scope.data.uploadStatus.success++;
                    $scope.data.uploadStatus.successWonumList.push(item.wonum);
                    $scope.checkUploadStatus();
                } else {
                    taskApi.uploadSucess(index.toString(), item.wonum, $scope.data.accountInfo.hrid, $scope.data.accountInfo.penum);
                    taskApi.successLoadingDialog();
                    $scope.checkEventReport(item.wonum);
                    $scope.data.tasklist.rcwolist.list.splice(index, 1);
                    $scope.checkSchedule();
                }
            } else if (res.isto) {
                if (syncAll) {
                    $scope.data.uploadStatus.failed++;
                    $scope.checkUploadStatus();
                } else {
                    taskApi.isTO(index.toString(), item.wonum, $scope.data.accountInfo.hrid, $scope.data.accountInfo.penum);
                    android.alert(res.message);
                    $scope.checkEventReport(item.wonum);
                    taskApi.failedLoadingDialog();
                    $scope.data.tasklist.rcwolist.list.splice(index, 1);
                    $scope.checkSchedule();
                }
            } else {
                if (syncAll) {
                    $scope.data.uploadStatus.failed++;
                    $scope.checkUploadStatus();
                } else {
                    android.alert(res.message);
                    taskApi.failedLoadingDialog();
                    $scope.checkEventReport(item.wonum);
                }
            }
        }).error(function () {
            if (syncAll) {
                $scope.data.uploadStatus.failed++;
                $scope.checkUploadStatus();
            } else {
                taskApi.failedLoadingDialog();
                $scope.checkEventReport(item.wonum);
            }
        });
    };
    $scope.checkUploadStatus = function () {
        if (this.data.uploadStatus.success + this.data.uploadStatus.failed == this.data.uploadStatus.total) {
            if (this.data.uploadStatus.successWonumList.length) {
                taskApi.deleteUploadRcwo(JSON.stringify(this.data.uploadStatus.successWonumList), this.data.accountInfo.hrid, this.data.accountInfo.penum);
                taskApi.successLoadingDialog();
            } else {
                taskApi.failedLoadingDialog();
            }
            this.checkEventReport();
            this.refreshUnfinished();
            this.data.uploadStatus.successWonumList = [];
            android.showToast(android.getCustomString("total_of_sync_rcwo", this.data.uploadStatus.success.toString()));
        }
    };
    $scope.refreshUnfinished = function () {
        android.setRefresh();
        this.data.pullToLoadMore.unfinished = {
            "show": false,
            "loading": false,
            "text": android.getString("loading")
        };
        this.data.myListConfig.unfinished.page = 0;
        this.getUnfinishedList(true);
    };
    $scope.checkEventReport = function (wonum) {
        if (wonum)
            this.data.eventReport.ERTotal = taskApi.getAllNewERTotalWithWonum(this.data.accountInfo.hrid, this.data.accountInfo.penum, wonum);
        else
            this.data.eventReport.ERTotal = taskApi.getAllNewERTotalWithWonum(this.data.accountInfo.hrid, this.data.accountInfo.penum, "");
        if (this.data.eventReport.ERTotal)
            this.startSyncER(wonum);
    }
    $scope.startSyncER = function (wonum) {
        taskApi.loadingDialog();
        taskApi.setERLoadingText();
        var index = 0;
        if (wonum)
            this.data.eventReport.ERList = JSON.parse(taskApi.getAllNewERWithWonum(this.data.accountInfo.hrid, this.data.accountInfo.penum, wonum));
        else
            this.data.eventReport.ERList = JSON.parse(taskApi.getAllNewERWithWonum(this.data.accountInfo.hrid, this.data.accountInfo.penum, ""))
        $interval(function () { //每个个报告延时两秒
            $scope.syncER($scope.data.eventReport.ERList[index++]);
        }, 2000, $scope.data.eventReport.ERTotal);
    }
    $scope.syncER = function (ER) {
        var data = {
            "hrid": $scope.data.accountInfo.hrid,
            "penum": $scope.data.accountInfo.penum,
            "wonum": ER.wonum,
            "description": ER.description,
            "locdesc": ER.locdesc,
            "priority": ER.priority,
            "vedios": [],
            "studios": []
        };
        var imgList = JSON.parse(taskApi.getImg(ER.ernum));
        if (imgList.pic1) {
            data.pic1 = imgList.pic1;
            if (imgList.pic2) {
                data.pic2 = imgList.pic2;
                if (imgList.pic3)
                    data.pic3 = imgList.pic3;
            }
        }

        var videosList = JSON.parse(ER.video);

        if(videosList.length) {
            videosList.forEach(function(video) {
                data.vedios.push("data:video/mp4;base64," + android.fileToBase64(video));
            });
        }
        if (ER.audio) {
            data.studios.push("data:audio/mp3;base64," + android.fileToBase64(ER.audio));
        }
        $http({
            url: $scope.data.reqUrl.syncER,
            data: data,
            method: "POST",
            responseType: "json",
            timeout: 10000
        }).success(function (res) {
            if (res.success) {
                taskApi.syncEventReport(ER.ernum, res.content.ernum);
                $scope.data.eventReport.success++;
                $scope.checkERSchedule()
            } else {
                $scope.data.eventReport.failed++;
                $scope.checkERSchedule();
            }
        }).error(function () {
            $scope.data.eventReport.failed++;
            $scope.checkERSchedule();
            $scope.data.eventReport.imgList = [];
        })
    }
    $scope.checkERSchedule = function () {
        if (this.data.eventReport.ERTotal == this.data.eventReport.success + this.data.eventReport.failed) {
            taskApi.hideLoadingDialog();
            android.showToast(android.getCustomString("total_of_sync_event_report", this.data.eventReport.success.toString()));
            this.data.eventReport.ERTotal = 0;
            this.data.eventReport.success = 0;
            this.data.eventReport.failed = 0;
        }
    }
});

function angularApply(callback) {
    if (!this.scope) {
        this.ele = angular.element(document.getElementById("myCtrl"));
        this.scope = ele.scope();
    }
    this.scope.$apply(callback);
}

function updateSchedule(pageData) {
    angularApply(function () {
        var json = JSON.parse(pageData);
        if(!json) return;
        scope.data.tasklist.rcwolist.list[json.index].schedule = json.schedule;
        if (json.schedule == "Completed") {
            var target = scope.data.tasklist.rcwolist.list[json.index];
            target.actionid = json.uploadActionid;
            if (target.type == '1') {
                target.reasoncancel = json.remarks;
                target.actexecutor = json.displayName;
                target.reasonnocomp = json.reasonnocomp;
                if (!json.remarks) {
                    target.actcompdate = json.actcompdate;
                }
                target.actcompdate = json.actcompdate;
            } else if (target.type == '2') {
                target.reasonreturn = json.remarks;
            }
            scope.checkSchedule();
        }
    });
}

function uploadSuccess(index) {
    angularApply(function () {
        if (index != -1) scope.data.tasklist.rcwolist.list.splice(index, 1);
    });
}

function pullToRefresh() {
    angularApply(function () {
        scope.refresh();
    });
}